/* AsyncTask.c generated by valac 0.40.8, the Vala compiler
 * generated from AsyncTask.vala, do not modify */

/*
 * AsyncTask.vala
 *
 * Copyright 2012-2018 Tony George <teejeetech@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 *
 *
 */


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <float.h>
#include <math.h>
#include <gio/gunixoutputstream.h>
#include <gio/gunixinputstream.h>
#include <unistd.h>


#define TYPE_ASYNC_TASK (async_task_get_type ())
#define ASYNC_TASK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ASYNC_TASK, AsyncTask))
#define ASYNC_TASK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ASYNC_TASK, AsyncTaskClass))
#define IS_ASYNC_TASK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ASYNC_TASK))
#define IS_ASYNC_TASK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ASYNC_TASK))
#define ASYNC_TASK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ASYNC_TASK, AsyncTaskClass))

typedef struct _AsyncTask AsyncTask;
typedef struct _AsyncTaskClass AsyncTaskClass;
typedef struct _AsyncTaskPrivate AsyncTaskPrivate;

#define TYPE_APP_STATUS (app_status_get_type ())
enum  {
	ASYNC_TASK_0_PROPERTY,
	ASYNC_TASK_STAT_TIME_ELAPSED_PROPERTY,
	ASYNC_TASK_STAT_TIME_REMAINING_PROPERTY,
	ASYNC_TASK_NUM_PROPERTIES
};
static GParamSpec* async_task_properties[ASYNC_TASK_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_timer_destroy0(var) ((var == NULL) ? NULL : (var = (g_timer_destroy (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
enum  {
	ASYNC_TASK_STDOUT_LINE_READ_SIGNAL,
	ASYNC_TASK_STDERR_LINE_READ_SIGNAL,
	ASYNC_TASK_TASK_COMPLETE_SIGNAL,
	ASYNC_TASK_NUM_SIGNALS
};
static guint async_task_signals[ASYNC_TASK_NUM_SIGNALS] = {0};

typedef enum  {
	APP_STATUS_NOT_STARTED,
	APP_STATUS_RUNNING,
	APP_STATUS_PAUSED,
	APP_STATUS_FINISHED,
	APP_STATUS_CANCELLED,
	APP_STATUS_PASSWORD_REQUIRED
} AppStatus;

struct _AsyncTask {
	GObject parent_instance;
	AsyncTaskPrivate * priv;
	GDataOutputStream* dos_log;
	gboolean is_terminated;
	GPid child_pid;
	gchar* script_file;
	gchar* working_dir;
	gchar* log_file;
	gboolean background_mode;
	AppStatus status;
	gchar* status_line;
	gint exit_code;
	gchar* error_msg;
	GTimer* timer;
	gdouble progress;
	gdouble percent;
	gint64 prg_count;
	gint64 prg_count_total;
	gint64 prg_bytes;
	gint64 prg_bytes_total;
	gchar* eta;
};

struct _AsyncTaskClass {
	GObjectClass parent_class;
	void (*parse_stdout_line) (AsyncTask* self, const gchar* out_line);
	void (*parse_stderr_line) (AsyncTask* self, const gchar* err_line);
	void (*finish_task) (AsyncTask* self);
};

struct _AsyncTaskPrivate {
	gchar* err_line;
	gchar* out_line;
	GDataOutputStream* dos_in;
	GDataInputStream* dis_out;
	GDataInputStream* dis_err;
	gboolean stdout_is_open;
	gboolean stderr_is_open;
	gint input_fd;
	gint output_fd;
	gint error_fd;
	gboolean finish_called;
};


static gpointer async_task_parent_class = NULL;
extern gchar* tee_jee_process_helper_TEMP_DIR;

GType async_task_get_type (void) G_GNUC_CONST;
GType app_status_get_type (void) G_GNUC_CONST;
#define ASYNC_TASK_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_ASYNC_TASK, AsyncTaskPrivate))
AsyncTask* async_task_construct (GType object_type);
gchar* tee_jee_misc_timestamp_for_path (void);
gchar* tee_jee_file_system_path_combine (const gchar* path1,
                                         const gchar* path2);
gboolean tee_jee_file_system_dir_create (const gchar* dir_path,
                                         gboolean show_message);
gboolean async_task_begin (AsyncTask* self);
void async_task_set_priority (AsyncTask* self);
void tee_jee_logging_log_debug (const gchar* message);
static void async_task_read_stdout (AsyncTask* self);
static gpointer _async_task_read_stdout_gthread_func (gpointer self);
void tee_jee_logging_log_error (const gchar* message,
                                gboolean highlight,
                                gboolean is_warning);
static void async_task_read_stderr (AsyncTask* self);
static gpointer _async_task_read_stderr_gthread_func (gpointer self);
void async_task_parse_stdout_line (AsyncTask* self,
                                   const gchar* out_line);
static void async_task_finish (AsyncTask* self);
void async_task_parse_stderr_line (AsyncTask* self,
                                   const gchar* err_line);
void async_task_write_stdin (AsyncTask* self,
                             const gchar* line);
static void async_task_real_parse_stdout_line (AsyncTask* self,
                                        const gchar* out_line);
static void async_task_real_parse_stderr_line (AsyncTask* self,
                                        const gchar* err_line);
gint async_task_read_exit_code (AsyncTask* self);
void async_task_finish_task (AsyncTask* self);
static void async_task_real_finish_task (AsyncTask* self);
gchar* tee_jee_file_system_file_parent (const gchar* file_path);
gboolean tee_jee_file_system_file_exists (const gchar* file_path);
gchar* tee_jee_file_system_file_read (const gchar* file_path);
gboolean async_task_is_running (AsyncTask* self);
void async_task_pause (AsyncTask* self);
gint* tee_jee_process_helper_get_process_children (GPid parent_pid,
                                                   int* result_length1);
gint tee_jee_process_helper_process_pause (GPid procID);
void async_task_resume (AsyncTask* self);
gint tee_jee_process_helper_process_resume (GPid procID);
void async_task_stop (AsyncTask* self,
                      AppStatus status_to_update);
void tee_jee_process_helper_process_quit (GPid process_pid,
                                          gboolean killChildren);
void async_task_set_priority_value (AsyncTask* self,
                                    gint prio);
void tee_jee_process_helper_process_set_priority (GPid procID,
                                                  gint prio);
void async_task_print_app_status (AsyncTask* self);
gchar* async_task_get_stat_time_elapsed (AsyncTask* self);
gulong tee_jee_system_timer_elapsed (GTimer* timer,
                                     gboolean stop);
gchar* tee_jee_misc_format_duration (glong millis);
gchar* async_task_get_stat_time_remaining (AsyncTask* self);
static void async_task_finalize (GObject * obj);
static void _vala_async_task_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


AsyncTask*
async_task_construct (GType object_type)
{
	AsyncTask * self = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	const gchar* _tmp10_;
#line 76 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	self = (AsyncTask*) g_object_new (object_type, NULL);
#line 77 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_tmp0_ = tee_jee_process_helper_TEMP_DIR;
#line 77 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_tmp1_ = g_strconcat (_tmp0_, "/", NULL);
#line 77 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_tmp2_ = _tmp1_;
#line 77 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_tmp3_ = tee_jee_misc_timestamp_for_path ();
#line 77 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_tmp4_ = _tmp3_;
#line 77 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_tmp5_ = g_strconcat (_tmp2_, _tmp4_, NULL);
#line 77 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_g_free0 (self->working_dir);
#line 77 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	self->working_dir = _tmp5_;
#line 77 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_g_free0 (_tmp4_);
#line 77 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_g_free0 (_tmp2_);
#line 78 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_tmp6_ = self->working_dir;
#line 78 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_tmp7_ = tee_jee_file_system_path_combine (_tmp6_, "script.sh");
#line 78 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_g_free0 (self->script_file);
#line 78 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	self->script_file = _tmp7_;
#line 79 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_tmp8_ = self->working_dir;
#line 79 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_tmp9_ = tee_jee_file_system_path_combine (_tmp8_, "task.log");
#line 79 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_g_free0 (self->log_file);
#line 79 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	self->log_file = _tmp9_;
#line 83 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_tmp10_ = self->working_dir;
#line 83 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	tee_jee_file_system_dir_create (_tmp10_, FALSE);
#line 76 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	return self;
#line 260 "AsyncTask.c"
}


static gpointer
_async_task_read_stdout_gthread_func (gpointer self)
{
	gpointer result;
#line 146 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	async_task_read_stdout ((AsyncTask*) self);
#line 270 "AsyncTask.c"
	result = NULL;
#line 146 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	g_object_unref (self);
#line 146 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	return result;
#line 276 "AsyncTask.c"
}


static gpointer
_async_task_read_stderr_gthread_func (gpointer self)
{
	gpointer result;
#line 154 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	async_task_read_stderr ((AsyncTask*) self);
#line 286 "AsyncTask.c"
	result = NULL;
#line 154 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	g_object_unref (self);
#line 154 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	return result;
#line 292 "AsyncTask.c"
}


gboolean
async_task_begin (AsyncTask* self)
{
	gboolean result = FALSE;
	gboolean has_started = FALSE;
	gchar* _tmp0_;
	gchar** spawn_args = NULL;
	gchar** _tmp1_;
	gint spawn_args_length1;
	gint _spawn_args_size_;
	gchar** _tmp2_;
	gint _tmp2__length1;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar** spawn_env = NULL;
	gchar** _tmp6_;
	gchar** _tmp7_;
	gint spawn_env_length1;
	gint _spawn_env_size_;
	GError * _inner_error_ = NULL;
#line 86 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 88 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	self->status = APP_STATUS_RUNNING;
#line 90 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	has_started = TRUE;
#line 91 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	self->is_terminated = FALSE;
#line 92 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	self->priv->finish_called = FALSE;
#line 94 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	self->prg_count = (gint64) 0;
#line 95 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	self->prg_bytes = (gint64) 0;
#line 96 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_tmp0_ = g_strdup ("");
#line 96 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_g_free0 (self->error_msg);
#line 96 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	self->error_msg = _tmp0_;
#line 98 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_tmp1_ = g_new0 (gchar*, 1 + 1);
#line 98 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	spawn_args = _tmp1_;
#line 98 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	spawn_args_length1 = 1;
#line 98 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_spawn_args_size_ = spawn_args_length1;
#line 99 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_tmp2_ = spawn_args;
#line 99 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_tmp2__length1 = spawn_args_length1;
#line 99 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_tmp3_ = self->script_file;
#line 99 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_tmp4_ = g_strdup (_tmp3_);
#line 99 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_g_free0 (_tmp2_[0]);
#line 99 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_tmp2_[0] = _tmp4_;
#line 99 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_tmp5_ = _tmp2_[0];
#line 101 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_tmp7_ = _tmp6_ = g_get_environ ();
#line 101 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	spawn_env = _tmp7_;
#line 101 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	spawn_env_length1 = _vala_array_length (_tmp6_);
#line 101 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_spawn_env_size_ = spawn_env_length1;
#line 367 "AsyncTask.c"
	{
		GTimer* _tmp8_;
		GTimer* _tmp9_;
		const gchar* _tmp10_;
		gchar** _tmp11_;
		gint _tmp11__length1;
		gchar** _tmp12_;
		gint _tmp12__length1;
		GPid _tmp13_ = 0;
		gint _tmp14_ = 0;
		gint _tmp15_ = 0;
		gint _tmp16_ = 0;
		GPid _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
		GUnixOutputStream* uos_in = NULL;
		gint _tmp20_;
		GUnixOutputStream* _tmp21_;
		GUnixInputStream* uis_out = NULL;
		gint _tmp22_;
		GUnixInputStream* _tmp23_;
		GUnixInputStream* uis_err = NULL;
		gint _tmp24_;
		GUnixInputStream* _tmp25_;
		GUnixOutputStream* _tmp26_;
		GDataOutputStream* _tmp27_;
		GUnixInputStream* _tmp28_;
		GDataInputStream* _tmp29_;
		GUnixInputStream* _tmp30_;
		GDataInputStream* _tmp31_;
		GDataInputStream* _tmp32_;
		GDataInputStream* _tmp33_;
		const gchar* _tmp34_;
		gint _tmp35_;
		gint _tmp36_;
#line 105 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_tmp8_ = g_timer_new ();
#line 105 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_g_timer_destroy0 (self->timer);
#line 105 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		self->timer = _tmp8_;
#line 106 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_tmp9_ = self->timer;
#line 106 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		g_timer_start (_tmp9_);
#line 109 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_tmp10_ = self->working_dir;
#line 109 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_tmp11_ = spawn_args;
#line 109 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_tmp11__length1 = spawn_args_length1;
#line 109 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_tmp12_ = spawn_env;
#line 109 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_tmp12__length1 = spawn_env_length1;
#line 109 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		g_spawn_async_with_pipes (_tmp10_, _tmp11_, _tmp12_, G_SPAWN_SEARCH_PATH, NULL, NULL, &_tmp13_, &_tmp14_, &_tmp15_, &_tmp16_, &_inner_error_);
#line 109 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		self->child_pid = _tmp13_;
#line 109 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		self->priv->input_fd = _tmp14_;
#line 109 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		self->priv->output_fd = _tmp15_;
#line 109 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		self->priv->error_fd = _tmp16_;
#line 109 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 435 "AsyncTask.c"
			goto __catch29_g_error;
		}
#line 120 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		async_task_set_priority (self);
#line 122 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_tmp17_ = self->child_pid;
#line 122 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_tmp18_ = g_strdup_printf ("AsyncTask: child_pid: %d", (gint) _tmp17_);
#line 122 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_tmp19_ = _tmp18_;
#line 122 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		tee_jee_logging_log_debug (_tmp19_);
#line 122 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_g_free0 (_tmp19_);
#line 125 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_tmp20_ = self->priv->input_fd;
#line 125 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_tmp21_ = (GUnixOutputStream*) g_unix_output_stream_new (_tmp20_, FALSE);
#line 125 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		uos_in = _tmp21_;
#line 126 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_tmp22_ = self->priv->output_fd;
#line 126 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_tmp23_ = (GUnixInputStream*) g_unix_input_stream_new (_tmp22_, FALSE);
#line 126 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		uis_out = _tmp23_;
#line 127 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_tmp24_ = self->priv->error_fd;
#line 127 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_tmp25_ = (GUnixInputStream*) g_unix_input_stream_new (_tmp24_, FALSE);
#line 127 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		uis_err = _tmp25_;
#line 128 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_tmp26_ = uos_in;
#line 128 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_tmp27_ = g_data_output_stream_new ((GOutputStream*) _tmp26_);
#line 128 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_g_object_unref0 (self->priv->dos_in);
#line 128 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		self->priv->dos_in = _tmp27_;
#line 129 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_tmp28_ = uis_out;
#line 129 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_tmp29_ = g_data_input_stream_new ((GInputStream*) _tmp28_);
#line 129 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_g_object_unref0 (self->priv->dis_out);
#line 129 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		self->priv->dis_out = _tmp29_;
#line 130 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_tmp30_ = uis_err;
#line 130 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_tmp31_ = g_data_input_stream_new ((GInputStream*) _tmp30_);
#line 130 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_g_object_unref0 (self->priv->dis_err);
#line 130 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		self->priv->dis_err = _tmp31_;
#line 131 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_tmp32_ = self->priv->dis_out;
#line 131 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		g_data_input_stream_set_newline_type (_tmp32_, G_DATA_STREAM_NEWLINE_TYPE_ANY);
#line 132 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_tmp33_ = self->priv->dis_err;
#line 132 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		g_data_input_stream_set_newline_type (_tmp33_, G_DATA_STREAM_NEWLINE_TYPE_ANY);
#line 135 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_tmp34_ = self->log_file;
#line 135 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_tmp35_ = strlen (_tmp34_);
#line 135 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_tmp36_ = _tmp35_;
#line 135 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		if (_tmp36_ > 0) {
#line 508 "AsyncTask.c"
			GFile* file = NULL;
			const gchar* _tmp37_;
			GFile* _tmp38_;
			GFile* _tmp39_;
			GFileOutputStream* file_stream = NULL;
			GFile* _tmp41_;
			GFileOutputStream* _tmp42_;
			GFileOutputStream* _tmp43_;
			GDataOutputStream* _tmp44_;
#line 136 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_tmp37_ = self->log_file;
#line 136 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_tmp38_ = g_file_new_for_path (_tmp37_);
#line 136 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			file = _tmp38_;
#line 137 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_tmp39_ = file;
#line 137 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			if (g_file_query_exists (_tmp39_, NULL)) {
#line 528 "AsyncTask.c"
				GFile* _tmp40_;
#line 138 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
				_tmp40_ = file;
#line 138 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
				g_file_delete (_tmp40_, NULL, &_inner_error_);
#line 138 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 138 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
					_g_object_unref0 (file);
#line 138 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
					_g_object_unref0 (uis_err);
#line 138 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
					_g_object_unref0 (uis_out);
#line 138 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
					_g_object_unref0 (uos_in);
#line 544 "AsyncTask.c"
					goto __catch29_g_error;
				}
			}
#line 140 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_tmp41_ = file;
#line 140 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_tmp42_ = g_file_create (_tmp41_, G_FILE_CREATE_REPLACE_DESTINATION, NULL, &_inner_error_);
#line 140 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			file_stream = _tmp42_;
#line 140 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 140 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
				_g_object_unref0 (file);
#line 140 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
				_g_object_unref0 (uis_err);
#line 140 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
				_g_object_unref0 (uis_out);
#line 140 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
				_g_object_unref0 (uos_in);
#line 564 "AsyncTask.c"
				goto __catch29_g_error;
			}
#line 141 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_tmp43_ = file_stream;
#line 141 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_tmp44_ = g_data_output_stream_new ((GOutputStream*) _tmp43_);
#line 141 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_g_object_unref0 (self->dos_log);
#line 141 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			self->dos_log = _tmp44_;
#line 135 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_g_object_unref0 (file_stream);
#line 135 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_g_object_unref0 (file);
#line 579 "AsyncTask.c"
		}
		{
#line 146 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			g_thread_create (_async_task_read_stdout_gthread_func, g_object_ref (self), TRUE, &_inner_error_);
#line 146 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 586 "AsyncTask.c"
				goto __catch30_g_error;
			}
		}
		goto __finally30;
		__catch30_g_error:
		{
			GError* e = NULL;
			GError* _tmp45_;
			const gchar* _tmp46_;
#line 144 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			e = _inner_error_;
#line 144 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_inner_error_ = NULL;
#line 148 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			tee_jee_logging_log_error ("AsyncTask.begin():create_thread:read_stdout()", FALSE, FALSE);
#line 149 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_tmp45_ = e;
#line 149 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_tmp46_ = _tmp45_->message;
#line 149 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			tee_jee_logging_log_error (_tmp46_, FALSE, FALSE);
#line 144 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_g_error_free0 (e);
#line 610 "AsyncTask.c"
		}
		__finally30:
#line 144 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 144 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_g_object_unref0 (uis_err);
#line 144 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_g_object_unref0 (uis_out);
#line 144 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_g_object_unref0 (uos_in);
#line 621 "AsyncTask.c"
			goto __catch29_g_error;
		}
		{
#line 154 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			g_thread_create (_async_task_read_stderr_gthread_func, g_object_ref (self), TRUE, &_inner_error_);
#line 154 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 629 "AsyncTask.c"
				goto __catch31_g_error;
			}
		}
		goto __finally31;
		__catch31_g_error:
		{
			GError* e = NULL;
			GError* _tmp47_;
			const gchar* _tmp48_;
#line 152 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			e = _inner_error_;
#line 152 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_inner_error_ = NULL;
#line 156 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			tee_jee_logging_log_error ("AsyncTask.begin():create_thread:read_stderr()", FALSE, FALSE);
#line 157 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_tmp47_ = e;
#line 157 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_tmp48_ = _tmp47_->message;
#line 157 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			tee_jee_logging_log_error (_tmp48_, FALSE, FALSE);
#line 152 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_g_error_free0 (e);
#line 653 "AsyncTask.c"
		}
		__finally31:
#line 152 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 152 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_g_object_unref0 (uis_err);
#line 152 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_g_object_unref0 (uis_out);
#line 152 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_g_object_unref0 (uos_in);
#line 664 "AsyncTask.c"
			goto __catch29_g_error;
		}
#line 103 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_g_object_unref0 (uis_err);
#line 103 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_g_object_unref0 (uis_out);
#line 103 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_g_object_unref0 (uos_in);
#line 673 "AsyncTask.c"
	}
	goto __finally29;
	__catch29_g_error:
	{
		GError* e = NULL;
		GError* _tmp49_;
		const gchar* _tmp50_;
#line 103 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		e = _inner_error_;
#line 103 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_inner_error_ = NULL;
#line 161 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		tee_jee_logging_log_error ("AsyncTask.begin()", FALSE, FALSE);
#line 162 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_tmp49_ = e;
#line 162 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_tmp50_ = _tmp49_->message;
#line 162 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		tee_jee_logging_log_error (_tmp50_, FALSE, FALSE);
#line 163 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		has_started = FALSE;
#line 103 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_g_error_free0 (e);
#line 697 "AsyncTask.c"
	}
	__finally29:
#line 103 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 702 "AsyncTask.c"
		gboolean _tmp51_ = FALSE;
#line 103 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		spawn_env = (_vala_array_free (spawn_env, spawn_env_length1, (GDestroyNotify) g_free), NULL);
#line 103 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		spawn_args = (_vala_array_free (spawn_args, spawn_args_length1, (GDestroyNotify) g_free), NULL);
#line 103 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 103 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		g_clear_error (&_inner_error_);
#line 103 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		return _tmp51_;
#line 714 "AsyncTask.c"
	}
#line 167 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	result = has_started;
#line 167 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	spawn_env = (_vala_array_free (spawn_env, spawn_env_length1, (GDestroyNotify) g_free), NULL);
#line 167 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	spawn_args = (_vala_array_free (spawn_args, spawn_args_length1, (GDestroyNotify) g_free), NULL);
#line 167 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	return result;
#line 724 "AsyncTask.c"
}


static void
async_task_read_stdout (AsyncTask* self)
{
	GError * _inner_error_ = NULL;
#line 170 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	g_return_if_fail (self != NULL);
#line 734 "AsyncTask.c"
	{
		gchar* _tmp0_ = NULL;
		GDataInputStream* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gboolean _tmp16_ = FALSE;
		GDataInputStream* _tmp17_;
		gint _tmp20_;
		gboolean _tmp21_ = FALSE;
		gboolean _tmp22_;
#line 172 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		self->priv->stdout_is_open = TRUE;
#line 174 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_tmp1_ = self->priv->dis_out;
#line 174 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_tmp2_ = g_data_input_stream_read_line (_tmp1_, NULL, NULL, &_inner_error_);
#line 174 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_tmp0_ = _tmp2_;
#line 174 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 755 "AsyncTask.c"
			goto __catch32_g_error;
		}
#line 174 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_tmp3_ = _tmp0_;
#line 174 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_tmp0_ = NULL;
#line 174 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_g_free0 (self->priv->out_line);
#line 174 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		self->priv->out_line = _tmp3_;
#line 175 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		while (TRUE) {
#line 768 "AsyncTask.c"
			const gchar* _tmp4_;
			gboolean _tmp5_ = FALSE;
			gboolean _tmp6_;
			gchar* _tmp12_ = NULL;
			GDataInputStream* _tmp13_;
			gchar* _tmp14_;
			gchar* _tmp15_;
#line 175 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_tmp4_ = self->priv->out_line;
#line 175 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			if (!(_tmp4_ != NULL)) {
#line 175 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
				break;
#line 782 "AsyncTask.c"
			}
#line 177 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_tmp6_ = self->is_terminated;
#line 177 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			if (!_tmp6_) {
#line 788 "AsyncTask.c"
				const gchar* _tmp7_;
				gint _tmp8_;
				gint _tmp9_;
#line 177 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
				_tmp7_ = self->priv->out_line;
#line 177 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
				_tmp8_ = strlen (_tmp7_);
#line 177 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
				_tmp9_ = _tmp8_;
#line 177 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
				_tmp5_ = _tmp9_ > 0;
#line 800 "AsyncTask.c"
			} else {
#line 177 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
				_tmp5_ = FALSE;
#line 804 "AsyncTask.c"
			}
#line 177 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			if (_tmp5_) {
#line 808 "AsyncTask.c"
				const gchar* _tmp10_;
				const gchar* _tmp11_;
#line 178 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
				_tmp10_ = self->priv->out_line;
#line 178 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
				async_task_parse_stdout_line (self, _tmp10_);
#line 179 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
				_tmp11_ = self->priv->out_line;
#line 179 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
				g_signal_emit (self, async_task_signals[ASYNC_TASK_STDOUT_LINE_READ_SIGNAL], 0, _tmp11_);
#line 819 "AsyncTask.c"
			}
#line 181 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_tmp13_ = self->priv->dis_out;
#line 181 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_tmp14_ = g_data_input_stream_read_line (_tmp13_, NULL, NULL, &_inner_error_);
#line 181 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_tmp12_ = _tmp14_;
#line 181 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 181 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
				_g_free0 (_tmp0_);
#line 831 "AsyncTask.c"
				goto __catch32_g_error;
			}
#line 181 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_tmp15_ = _tmp12_;
#line 181 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_tmp12_ = NULL;
#line 181 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_g_free0 (self->priv->out_line);
#line 181 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			self->priv->out_line = _tmp15_;
#line 175 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_g_free0 (_tmp12_);
#line 844 "AsyncTask.c"
		}
#line 184 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		self->priv->stdout_is_open = FALSE;
#line 187 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_tmp17_ = self->priv->dis_out;
#line 187 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		if (_tmp17_ != NULL) {
#line 852 "AsyncTask.c"
			GDataInputStream* _tmp18_;
#line 187 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_tmp18_ = self->priv->dis_out;
#line 187 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_tmp16_ = !g_input_stream_is_closed ((GInputStream*) _tmp18_);
#line 858 "AsyncTask.c"
		} else {
#line 187 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_tmp16_ = FALSE;
#line 862 "AsyncTask.c"
		}
#line 187 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		if (_tmp16_) {
#line 866 "AsyncTask.c"
			GDataInputStream* _tmp19_;
#line 188 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_tmp19_ = self->priv->dis_out;
#line 188 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			g_input_stream_close ((GInputStream*) _tmp19_, NULL, &_inner_error_);
#line 188 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 188 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
				_g_free0 (_tmp0_);
#line 876 "AsyncTask.c"
				goto __catch32_g_error;
			}
		}
#line 191 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_g_object_unref0 (self->priv->dis_out);
#line 191 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		self->priv->dis_out = NULL;
#line 192 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_tmp20_ = self->priv->output_fd;
#line 192 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		close (_tmp20_);
#line 195 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_tmp22_ = self->priv->stdout_is_open;
#line 195 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		if (!_tmp22_) {
#line 892 "AsyncTask.c"
			gboolean _tmp23_;
#line 195 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_tmp23_ = self->priv->stderr_is_open;
#line 195 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_tmp21_ = !_tmp23_;
#line 898 "AsyncTask.c"
		} else {
#line 195 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_tmp21_ = FALSE;
#line 902 "AsyncTask.c"
		}
#line 195 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		if (_tmp21_) {
#line 196 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			async_task_finish (self);
#line 908 "AsyncTask.c"
		}
#line 171 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_g_free0 (_tmp0_);
#line 912 "AsyncTask.c"
	}
	goto __finally32;
	__catch32_g_error:
	{
		GError* e = NULL;
		GError* _tmp24_;
		const gchar* _tmp25_;
#line 171 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		e = _inner_error_;
#line 171 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_inner_error_ = NULL;
#line 200 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		tee_jee_logging_log_error ("AsyncTask.read_stdout()", FALSE, FALSE);
#line 201 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_tmp24_ = e;
#line 201 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_tmp25_ = _tmp24_->message;
#line 201 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		tee_jee_logging_log_error (_tmp25_, FALSE, FALSE);
#line 171 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_g_error_free0 (e);
#line 934 "AsyncTask.c"
	}
	__finally32:
#line 171 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 171 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 171 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		g_clear_error (&_inner_error_);
#line 171 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		return;
#line 945 "AsyncTask.c"
	}
}


static void
async_task_read_stderr (AsyncTask* self)
{
	GError * _inner_error_ = NULL;
#line 205 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	g_return_if_fail (self != NULL);
#line 956 "AsyncTask.c"
	{
		gchar* _tmp0_ = NULL;
		GDataInputStream* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gboolean _tmp21_ = FALSE;
		GDataInputStream* _tmp22_;
		gint _tmp25_;
		gboolean _tmp26_ = FALSE;
		gboolean _tmp27_;
#line 207 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		self->priv->stderr_is_open = TRUE;
#line 209 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_tmp1_ = self->priv->dis_err;
#line 209 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_tmp2_ = g_data_input_stream_read_line (_tmp1_, NULL, NULL, &_inner_error_);
#line 209 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_tmp0_ = _tmp2_;
#line 209 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 977 "AsyncTask.c"
			goto __catch33_g_error;
		}
#line 209 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_tmp3_ = _tmp0_;
#line 209 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_tmp0_ = NULL;
#line 209 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_g_free0 (self->priv->err_line);
#line 209 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		self->priv->err_line = _tmp3_;
#line 210 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		while (TRUE) {
#line 990 "AsyncTask.c"
			const gchar* _tmp4_;
			gboolean _tmp5_ = FALSE;
			gboolean _tmp6_;
			gchar* _tmp17_ = NULL;
			GDataInputStream* _tmp18_;
			gchar* _tmp19_;
			gchar* _tmp20_;
#line 210 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_tmp4_ = self->priv->err_line;
#line 210 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			if (!(_tmp4_ != NULL)) {
#line 210 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
				break;
#line 1004 "AsyncTask.c"
			}
#line 211 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_tmp6_ = self->is_terminated;
#line 211 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			if (!_tmp6_) {
#line 1010 "AsyncTask.c"
				const gchar* _tmp7_;
				gint _tmp8_;
				gint _tmp9_;
#line 211 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
				_tmp7_ = self->priv->err_line;
#line 211 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
				_tmp8_ = strlen (_tmp7_);
#line 211 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
				_tmp9_ = _tmp8_;
#line 211 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
				_tmp5_ = _tmp9_ > 0;
#line 1022 "AsyncTask.c"
			} else {
#line 211 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
				_tmp5_ = FALSE;
#line 1026 "AsyncTask.c"
			}
#line 211 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			if (_tmp5_) {
#line 1030 "AsyncTask.c"
				const gchar* _tmp10_;
				const gchar* _tmp11_;
				gchar* _tmp12_;
				gchar* _tmp13_;
				gchar* _tmp14_;
				const gchar* _tmp15_;
				const gchar* _tmp16_;
#line 212 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
				_tmp10_ = self->error_msg;
#line 212 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
				_tmp11_ = self->priv->err_line;
#line 212 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
				_tmp12_ = g_strdup_printf ("%s\n", _tmp11_);
#line 212 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
				_tmp13_ = _tmp12_;
#line 212 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
				_tmp14_ = g_strconcat (_tmp10_, _tmp13_, NULL);
#line 212 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
				_g_free0 (self->error_msg);
#line 212 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
				self->error_msg = _tmp14_;
#line 212 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
				_g_free0 (_tmp13_);
#line 214 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
				_tmp15_ = self->priv->err_line;
#line 214 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
				async_task_parse_stderr_line (self, _tmp15_);
#line 215 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
				_tmp16_ = self->priv->err_line;
#line 215 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
				g_signal_emit (self, async_task_signals[ASYNC_TASK_STDERR_LINE_READ_SIGNAL], 0, _tmp16_);
#line 1062 "AsyncTask.c"
			}
#line 217 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_tmp18_ = self->priv->dis_err;
#line 217 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_tmp19_ = g_data_input_stream_read_line (_tmp18_, NULL, NULL, &_inner_error_);
#line 217 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_tmp17_ = _tmp19_;
#line 217 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 217 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
				_g_free0 (_tmp0_);
#line 1074 "AsyncTask.c"
				goto __catch33_g_error;
			}
#line 217 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_tmp20_ = _tmp17_;
#line 217 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_tmp17_ = NULL;
#line 217 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_g_free0 (self->priv->err_line);
#line 217 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			self->priv->err_line = _tmp20_;
#line 210 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_g_free0 (_tmp17_);
#line 1087 "AsyncTask.c"
		}
#line 220 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		self->priv->stderr_is_open = FALSE;
#line 223 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_tmp22_ = self->priv->dis_err;
#line 223 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		if (_tmp22_ != NULL) {
#line 1095 "AsyncTask.c"
			GDataInputStream* _tmp23_;
#line 223 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_tmp23_ = self->priv->dis_err;
#line 223 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_tmp21_ = !g_input_stream_is_closed ((GInputStream*) _tmp23_);
#line 1101 "AsyncTask.c"
		} else {
#line 223 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_tmp21_ = FALSE;
#line 1105 "AsyncTask.c"
		}
#line 223 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		if (_tmp21_) {
#line 1109 "AsyncTask.c"
			GDataInputStream* _tmp24_;
#line 224 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_tmp24_ = self->priv->dis_err;
#line 224 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			g_input_stream_close ((GInputStream*) _tmp24_, NULL, &_inner_error_);
#line 224 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 224 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
				_g_free0 (_tmp0_);
#line 1119 "AsyncTask.c"
				goto __catch33_g_error;
			}
		}
#line 227 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_g_object_unref0 (self->priv->dis_err);
#line 227 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		self->priv->dis_err = NULL;
#line 228 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_tmp25_ = self->priv->error_fd;
#line 228 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		close (_tmp25_);
#line 231 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_tmp27_ = self->priv->stdout_is_open;
#line 231 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		if (!_tmp27_) {
#line 1135 "AsyncTask.c"
			gboolean _tmp28_;
#line 231 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_tmp28_ = self->priv->stderr_is_open;
#line 231 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_tmp26_ = !_tmp28_;
#line 1141 "AsyncTask.c"
		} else {
#line 231 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_tmp26_ = FALSE;
#line 1145 "AsyncTask.c"
		}
#line 231 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		if (_tmp26_) {
#line 232 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			async_task_finish (self);
#line 1151 "AsyncTask.c"
		}
#line 206 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_g_free0 (_tmp0_);
#line 1155 "AsyncTask.c"
	}
	goto __finally33;
	__catch33_g_error:
	{
		GError* e = NULL;
		GError* _tmp29_;
		const gchar* _tmp30_;
#line 206 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		e = _inner_error_;
#line 206 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_inner_error_ = NULL;
#line 236 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		tee_jee_logging_log_error ("AsyncTask.read_stderr()", FALSE, FALSE);
#line 237 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_tmp29_ = e;
#line 237 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_tmp30_ = _tmp29_->message;
#line 237 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		tee_jee_logging_log_error (_tmp30_, FALSE, FALSE);
#line 206 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_g_error_free0 (e);
#line 1177 "AsyncTask.c"
	}
	__finally33:
#line 206 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 206 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 206 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		g_clear_error (&_inner_error_);
#line 206 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		return;
#line 1188 "AsyncTask.c"
	}
}


void
async_task_write_stdin (AsyncTask* self,
                        const gchar* line)
{
	GError * _inner_error_ = NULL;
#line 241 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	g_return_if_fail (self != NULL);
#line 241 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	g_return_if_fail (line != NULL);
#line 1202 "AsyncTask.c"
	{
		AppStatus _tmp0_;
#line 243 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_tmp0_ = self->status;
#line 243 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		if (_tmp0_ == APP_STATUS_RUNNING) {
#line 1209 "AsyncTask.c"
			GDataOutputStream* _tmp1_;
			gchar* _tmp2_;
			gchar* _tmp3_;
#line 244 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_tmp1_ = self->priv->dos_in;
#line 244 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_tmp2_ = g_strconcat (line, "\n", NULL);
#line 244 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_tmp3_ = _tmp2_;
#line 244 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			g_data_output_stream_put_string (_tmp1_, _tmp3_, NULL, &_inner_error_);
#line 244 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_g_free0 (_tmp3_);
#line 244 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1225 "AsyncTask.c"
				goto __catch34_g_error;
			}
		} else {
#line 247 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			tee_jee_logging_log_error ("AsyncTask.write_stdin(): NOT RUNNING", FALSE, FALSE);
#line 1231 "AsyncTask.c"
		}
	}
	goto __finally34;
	__catch34_g_error:
	{
		GError* e = NULL;
		gchar* _tmp4_;
		gchar* _tmp5_;
		GError* _tmp6_;
		const gchar* _tmp7_;
#line 242 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		e = _inner_error_;
#line 242 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_inner_error_ = NULL;
#line 251 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_tmp4_ = g_strdup_printf ("AsyncTask.write_stdin(): %s", line);
#line 251 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_tmp5_ = _tmp4_;
#line 251 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		tee_jee_logging_log_error (_tmp5_, FALSE, FALSE);
#line 251 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_g_free0 (_tmp5_);
#line 252 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_tmp6_ = e;
#line 252 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_tmp7_ = _tmp6_->message;
#line 252 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		tee_jee_logging_log_error (_tmp7_, FALSE, FALSE);
#line 242 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_g_error_free0 (e);
#line 1262 "AsyncTask.c"
	}
	__finally34:
#line 242 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 242 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 242 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		g_clear_error (&_inner_error_);
#line 242 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		return;
#line 1273 "AsyncTask.c"
	}
}


static void
async_task_real_parse_stdout_line (AsyncTask* self,
                                   const gchar* out_line)
{
#line 256 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	g_critical ("Type `%s' does not implement abstract method `async_task_parse_stdout_line'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 256 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	return;
#line 1286 "AsyncTask.c"
}


void
async_task_parse_stdout_line (AsyncTask* self,
                              const gchar* out_line)
{
#line 256 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	g_return_if_fail (self != NULL);
#line 256 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	ASYNC_TASK_GET_CLASS (self)->parse_stdout_line (self, out_line);
#line 1298 "AsyncTask.c"
}


static void
async_task_real_parse_stderr_line (AsyncTask* self,
                                   const gchar* err_line)
{
#line 258 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	g_critical ("Type `%s' does not implement abstract method `async_task_parse_stderr_line'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 258 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	return;
#line 1310 "AsyncTask.c"
}


void
async_task_parse_stderr_line (AsyncTask* self,
                              const gchar* err_line)
{
#line 258 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	g_return_if_fail (self != NULL);
#line 258 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	ASYNC_TASK_GET_CLASS (self)->parse_stderr_line (self, err_line);
#line 1322 "AsyncTask.c"
}


static void
async_task_finish (AsyncTask* self)
{
	gboolean _tmp0_;
	gint _tmp7_;
	GPid _tmp8_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	GTimer* _tmp18_;
	gboolean _tmp19_ = FALSE;
	AppStatus _tmp20_;
	GError * _inner_error_ = NULL;
#line 260 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	g_return_if_fail (self != NULL);
#line 262 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_tmp0_ = self->priv->finish_called;
#line 262 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	if (_tmp0_) {
#line 262 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		return;
#line 1347 "AsyncTask.c"
	}
#line 263 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	self->priv->finish_called = TRUE;
#line 265 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	tee_jee_logging_log_debug ("AsyncTask: finish(): enter");
#line 1353 "AsyncTask.c"
	{
		gboolean _tmp1_ = FALSE;
		gboolean _tmp2_ = FALSE;
		GDataOutputStream* _tmp3_;
#line 269 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_tmp3_ = self->priv->dos_in;
#line 269 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		if (_tmp3_ != NULL) {
#line 1362 "AsyncTask.c"
			GDataOutputStream* _tmp4_;
#line 269 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_tmp4_ = self->priv->dos_in;
#line 269 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_tmp2_ = !g_output_stream_is_closed ((GOutputStream*) _tmp4_);
#line 1368 "AsyncTask.c"
		} else {
#line 269 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_tmp2_ = FALSE;
#line 1372 "AsyncTask.c"
		}
#line 269 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		if (_tmp2_) {
#line 1376 "AsyncTask.c"
			GDataOutputStream* _tmp5_;
#line 269 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_tmp5_ = self->priv->dos_in;
#line 269 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_tmp1_ = !g_output_stream_is_closing ((GOutputStream*) _tmp5_);
#line 1382 "AsyncTask.c"
		} else {
#line 269 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_tmp1_ = FALSE;
#line 1386 "AsyncTask.c"
		}
#line 269 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		if (_tmp1_) {
#line 1390 "AsyncTask.c"
			GDataOutputStream* _tmp6_;
#line 270 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_tmp6_ = self->priv->dos_in;
#line 270 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			g_output_stream_close ((GOutputStream*) _tmp6_, NULL, &_inner_error_);
#line 270 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1398 "AsyncTask.c"
				goto __catch35_g_error;
			}
		}
	}
	goto __finally35;
	__catch35_g_error:
	{
		GError* e = NULL;
#line 268 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		e = _inner_error_;
#line 268 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_inner_error_ = NULL;
#line 268 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_g_error_free0 (e);
#line 1413 "AsyncTask.c"
	}
	__finally35:
#line 268 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 268 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 268 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		g_clear_error (&_inner_error_);
#line 268 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		return;
#line 1424 "AsyncTask.c"
	}
#line 279 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_g_object_unref0 (self->priv->dos_in);
#line 279 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	self->priv->dos_in = NULL;
#line 280 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_tmp7_ = self->priv->input_fd;
#line 280 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	close (_tmp7_);
#line 283 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_tmp8_ = self->child_pid;
#line 283 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	g_spawn_close_pid (_tmp8_);
#line 1438 "AsyncTask.c"
	{
		gboolean _tmp9_ = FALSE;
		gboolean _tmp10_ = FALSE;
		GDataOutputStream* _tmp11_;
#line 287 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_tmp11_ = self->dos_log;
#line 287 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		if (_tmp11_ != NULL) {
#line 1447 "AsyncTask.c"
			GDataOutputStream* _tmp12_;
#line 287 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_tmp12_ = self->dos_log;
#line 287 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_tmp10_ = !g_output_stream_is_closed ((GOutputStream*) _tmp12_);
#line 1453 "AsyncTask.c"
		} else {
#line 287 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_tmp10_ = FALSE;
#line 1457 "AsyncTask.c"
		}
#line 287 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		if (_tmp10_) {
#line 1461 "AsyncTask.c"
			GDataOutputStream* _tmp13_;
#line 287 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_tmp13_ = self->dos_log;
#line 287 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_tmp9_ = !g_output_stream_is_closing ((GOutputStream*) _tmp13_);
#line 1467 "AsyncTask.c"
		} else {
#line 287 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_tmp9_ = FALSE;
#line 1471 "AsyncTask.c"
		}
#line 287 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		if (_tmp9_) {
#line 1475 "AsyncTask.c"
			GDataOutputStream* _tmp14_;
#line 288 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_tmp14_ = self->dos_log;
#line 288 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			g_output_stream_close ((GOutputStream*) _tmp14_, NULL, &_inner_error_);
#line 288 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1483 "AsyncTask.c"
				goto __catch36_g_error;
			}
		}
#line 290 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_g_object_unref0 (self->dos_log);
#line 290 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		self->dos_log = NULL;
#line 1491 "AsyncTask.c"
	}
	goto __finally36;
	__catch36_g_error:
	{
		GError* e = NULL;
#line 285 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		e = _inner_error_;
#line 285 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_inner_error_ = NULL;
#line 285 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_g_error_free0 (e);
#line 1503 "AsyncTask.c"
	}
	__finally36:
#line 285 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 285 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 285 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		g_clear_error (&_inner_error_);
#line 285 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		return;
#line 1514 "AsyncTask.c"
	}
#line 298 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	async_task_read_exit_code (self);
#line 300 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_tmp15_ = g_strdup ("");
#line 300 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_g_free0 (self->status_line);
#line 300 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	self->status_line = _tmp15_;
#line 301 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_tmp16_ = g_strdup ("");
#line 301 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_g_free0 (self->priv->err_line);
#line 301 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	self->priv->err_line = _tmp16_;
#line 302 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_tmp17_ = g_strdup ("");
#line 302 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_g_free0 (self->priv->out_line);
#line 302 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	self->priv->out_line = _tmp17_;
#line 304 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_tmp18_ = self->timer;
#line 304 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	g_timer_stop (_tmp18_);
#line 306 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	async_task_finish_task (self);
#line 308 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_tmp20_ = self->status;
#line 308 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	if (_tmp20_ != APP_STATUS_CANCELLED) {
#line 1546 "AsyncTask.c"
		AppStatus _tmp21_;
#line 308 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_tmp21_ = self->status;
#line 308 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_tmp19_ = _tmp21_ != APP_STATUS_PASSWORD_REQUIRED;
#line 1552 "AsyncTask.c"
	} else {
#line 308 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_tmp19_ = FALSE;
#line 1556 "AsyncTask.c"
	}
#line 308 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	if (_tmp19_) {
#line 309 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		self->status = APP_STATUS_FINISHED;
#line 1562 "AsyncTask.c"
	}
#line 314 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	g_signal_emit (self, async_task_signals[ASYNC_TASK_TASK_COMPLETE_SIGNAL], 0);
#line 1566 "AsyncTask.c"
}


static void
async_task_real_finish_task (AsyncTask* self)
{
#line 317 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	g_critical ("Type `%s' does not implement abstract method `async_task_finish_task'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 317 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	return;
#line 1577 "AsyncTask.c"
}


void
async_task_finish_task (AsyncTask* self)
{
#line 317 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	g_return_if_fail (self != NULL);
#line 317 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	ASYNC_TASK_GET_CLASS (self)->finish_task (self);
#line 1588 "AsyncTask.c"
}


gint
async_task_read_exit_code (AsyncTask* self)
{
	gint result = 0;
	gchar* path = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	gint _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gint _tmp12_;
#line 319 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 320 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	self->exit_code = -1;
#line 321 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_tmp0_ = self->script_file;
#line 321 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_tmp1_ = tee_jee_file_system_file_parent (_tmp0_);
#line 321 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_tmp2_ = _tmp1_;
#line 321 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_tmp3_ = g_strconcat (_tmp2_, "/status", NULL);
#line 321 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_tmp4_ = _tmp3_;
#line 321 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_g_free0 (_tmp2_);
#line 321 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	path = _tmp4_;
#line 322 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_tmp5_ = path;
#line 322 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	if (tee_jee_file_system_file_exists (_tmp5_)) {
#line 1629 "AsyncTask.c"
		gchar* txt = NULL;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		const gchar* _tmp8_;
#line 323 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_tmp6_ = path;
#line 323 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_tmp7_ = tee_jee_file_system_file_read (_tmp6_);
#line 323 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		txt = _tmp7_;
#line 324 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_tmp8_ = txt;
#line 324 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		self->exit_code = atoi (_tmp8_);
#line 322 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_g_free0 (txt);
#line 1646 "AsyncTask.c"
	}
#line 326 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_tmp9_ = self->exit_code;
#line 326 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_tmp10_ = g_strdup_printf ("exit_code: %d", _tmp9_);
#line 326 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_tmp11_ = _tmp10_;
#line 326 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	tee_jee_logging_log_debug (_tmp11_);
#line 326 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_g_free0 (_tmp11_);
#line 327 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_tmp12_ = self->exit_code;
#line 327 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	result = _tmp12_;
#line 327 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_g_free0 (path);
#line 327 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	return result;
#line 1666 "AsyncTask.c"
}


gboolean
async_task_is_running (AsyncTask* self)
{
	gboolean result = FALSE;
	AppStatus _tmp0_;
#line 330 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 331 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_tmp0_ = self->status;
#line 331 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	result = _tmp0_ == APP_STATUS_RUNNING;
#line 331 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	return result;
#line 1683 "AsyncTask.c"
}


void
async_task_pause (AsyncTask* self)
{
	GPid sub_child_pid = 0;
	GPid _tmp0_;
	gint _tmp1_;
	gint* _tmp2_;
#line 336 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	g_return_if_fail (self != NULL);
#line 338 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_tmp0_ = self->child_pid;
#line 338 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_tmp2_ = tee_jee_process_helper_get_process_children (_tmp0_, &_tmp1_);
#line 1700 "AsyncTask.c"
	{
		gint* pid_collection = NULL;
		gint pid_collection_length1 = 0;
		gint _pid_collection_size_ = 0;
		gint pid_it = 0;
#line 338 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		pid_collection = _tmp2_;
#line 338 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		pid_collection_length1 = _tmp1_;
#line 338 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		for (pid_it = 0; pid_it < _tmp1_; pid_it = pid_it + 1) {
#line 1712 "AsyncTask.c"
			glong pid = 0L;
#line 338 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			pid = (glong) pid_collection[pid_it];
#line 1716 "AsyncTask.c"
			{
				glong _tmp3_;
				GPid _tmp4_;
#line 339 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
				_tmp3_ = pid;
#line 339 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
				sub_child_pid = (GPid) _tmp3_;
#line 340 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
				_tmp4_ = sub_child_pid;
#line 340 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
				tee_jee_process_helper_process_pause (_tmp4_);
#line 1728 "AsyncTask.c"
			}
		}
#line 338 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		pid_collection = (g_free (pid_collection), NULL);
#line 1733 "AsyncTask.c"
	}
#line 343 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	self->status = APP_STATUS_PAUSED;
#line 1737 "AsyncTask.c"
}


void
async_task_resume (AsyncTask* self)
{
	GPid sub_child_pid = 0;
	GPid _tmp0_;
	gint _tmp1_;
	gint* _tmp2_;
#line 346 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	g_return_if_fail (self != NULL);
#line 348 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_tmp0_ = self->child_pid;
#line 348 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_tmp2_ = tee_jee_process_helper_get_process_children (_tmp0_, &_tmp1_);
#line 1754 "AsyncTask.c"
	{
		gint* pid_collection = NULL;
		gint pid_collection_length1 = 0;
		gint _pid_collection_size_ = 0;
		gint pid_it = 0;
#line 348 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		pid_collection = _tmp2_;
#line 348 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		pid_collection_length1 = _tmp1_;
#line 348 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		for (pid_it = 0; pid_it < _tmp1_; pid_it = pid_it + 1) {
#line 1766 "AsyncTask.c"
			glong pid = 0L;
#line 348 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			pid = (glong) pid_collection[pid_it];
#line 1770 "AsyncTask.c"
			{
				glong _tmp3_;
				GPid _tmp4_;
#line 349 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
				_tmp3_ = pid;
#line 349 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
				sub_child_pid = (GPid) _tmp3_;
#line 350 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
				_tmp4_ = sub_child_pid;
#line 350 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
				tee_jee_process_helper_process_resume (_tmp4_);
#line 1782 "AsyncTask.c"
			}
		}
#line 348 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		pid_collection = (g_free (pid_collection), NULL);
#line 1787 "AsyncTask.c"
	}
#line 353 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	self->status = APP_STATUS_RUNNING;
#line 1791 "AsyncTask.c"
}


void
async_task_stop (AsyncTask* self,
                 AppStatus status_to_update)
{
	AppStatus _tmp0_;
	GPid _tmp1_;
	GPid _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
#line 356 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	g_return_if_fail (self != NULL);
#line 358 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_tmp0_ = self->status;
#line 358 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	if (_tmp0_ == APP_STATUS_PAUSED) {
#line 359 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		async_task_resume (self);
#line 1812 "AsyncTask.c"
	}
#line 362 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	self->status = status_to_update;
#line 364 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_tmp1_ = self->child_pid;
#line 364 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	tee_jee_process_helper_process_quit (_tmp1_, TRUE);
#line 366 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_tmp2_ = self->child_pid;
#line 366 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_tmp3_ = g_strdup_printf ("process_quit: %d", (gint) _tmp2_);
#line 366 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_tmp4_ = _tmp3_;
#line 366 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	tee_jee_logging_log_debug (_tmp4_);
#line 366 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_g_free0 (_tmp4_);
#line 1830 "AsyncTask.c"
}


void
async_task_set_priority (AsyncTask* self)
{
	gboolean _tmp0_;
#line 369 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	g_return_if_fail (self != NULL);
#line 370 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_tmp0_ = self->background_mode;
#line 370 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	if (_tmp0_) {
#line 371 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		async_task_set_priority_value (self, 5);
#line 1846 "AsyncTask.c"
	} else {
#line 374 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		async_task_set_priority_value (self, 0);
#line 1850 "AsyncTask.c"
	}
}


void
async_task_set_priority_value (AsyncTask* self,
                               gint prio)
{
	GPid app_pid = 0;
	GPid _tmp0_;
	AppStatus _tmp1_;
#line 378 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	g_return_if_fail (self != NULL);
#line 379 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	app_pid = (GPid) getpid ();
#line 380 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_tmp0_ = app_pid;
#line 380 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	tee_jee_process_helper_process_set_priority (_tmp0_, prio);
#line 382 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_tmp1_ = self->status;
#line 382 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	if (_tmp1_ == APP_STATUS_RUNNING) {
#line 1874 "AsyncTask.c"
		GPid _tmp2_;
		GPid sub_child_pid = 0;
		GPid _tmp3_;
		gint _tmp4_;
		gint* _tmp5_;
#line 383 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_tmp2_ = self->child_pid;
#line 383 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		tee_jee_process_helper_process_set_priority (_tmp2_, prio);
#line 386 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_tmp3_ = self->child_pid;
#line 386 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_tmp5_ = tee_jee_process_helper_get_process_children (_tmp3_, &_tmp4_);
#line 1888 "AsyncTask.c"
		{
			gint* pid_collection = NULL;
			gint pid_collection_length1 = 0;
			gint _pid_collection_size_ = 0;
			gint pid_it = 0;
#line 386 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			pid_collection = _tmp5_;
#line 386 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			pid_collection_length1 = _tmp4_;
#line 386 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			for (pid_it = 0; pid_it < _tmp4_; pid_it = pid_it + 1) {
#line 1900 "AsyncTask.c"
				glong pid = 0L;
#line 386 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
				pid = (glong) pid_collection[pid_it];
#line 1904 "AsyncTask.c"
				{
					glong _tmp6_;
					GPid _tmp7_;
#line 387 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
					_tmp6_ = pid;
#line 387 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
					sub_child_pid = (GPid) _tmp6_;
#line 388 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
					_tmp7_ = sub_child_pid;
#line 388 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
					tee_jee_process_helper_process_set_priority (_tmp7_, prio);
#line 1916 "AsyncTask.c"
				}
			}
#line 386 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			pid_collection = (g_free (pid_collection), NULL);
#line 1921 "AsyncTask.c"
		}
	}
}


void
async_task_print_app_status (AsyncTask* self)
{
	AppStatus _tmp0_;
#line 416 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	g_return_if_fail (self != NULL);
#line 417 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_tmp0_ = self->status;
#line 417 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	switch (_tmp0_) {
#line 417 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		case APP_STATUS_NOT_STARTED:
#line 1939 "AsyncTask.c"
		{
			gchar* _tmp1_;
			gchar* _tmp2_;
#line 419 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_tmp1_ = g_strdup_printf ("status=%s", "NOT_STARTED");
#line 419 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_tmp2_ = _tmp1_;
#line 419 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			tee_jee_logging_log_debug (_tmp2_);
#line 419 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_g_free0 (_tmp2_);
#line 420 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			break;
#line 1953 "AsyncTask.c"
		}
#line 417 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		case APP_STATUS_RUNNING:
#line 1957 "AsyncTask.c"
		{
			gchar* _tmp3_;
			gchar* _tmp4_;
#line 422 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_tmp3_ = g_strdup_printf ("status=%s", "RUNNING");
#line 422 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_tmp4_ = _tmp3_;
#line 422 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			tee_jee_logging_log_debug (_tmp4_);
#line 422 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_g_free0 (_tmp4_);
#line 423 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			break;
#line 1971 "AsyncTask.c"
		}
#line 417 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		case APP_STATUS_PAUSED:
#line 1975 "AsyncTask.c"
		{
			gchar* _tmp5_;
			gchar* _tmp6_;
#line 425 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_tmp5_ = g_strdup_printf ("status=%s", "PAUSED");
#line 425 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_tmp6_ = _tmp5_;
#line 425 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			tee_jee_logging_log_debug (_tmp6_);
#line 425 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_g_free0 (_tmp6_);
#line 426 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			break;
#line 1989 "AsyncTask.c"
		}
#line 417 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		case APP_STATUS_FINISHED:
#line 1993 "AsyncTask.c"
		{
			gchar* _tmp7_;
			gchar* _tmp8_;
#line 428 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_tmp7_ = g_strdup_printf ("status=%s", "FINISHED");
#line 428 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_tmp8_ = _tmp7_;
#line 428 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			tee_jee_logging_log_debug (_tmp8_);
#line 428 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_g_free0 (_tmp8_);
#line 429 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			break;
#line 2007 "AsyncTask.c"
		}
#line 417 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		case APP_STATUS_CANCELLED:
#line 2011 "AsyncTask.c"
		{
			gchar* _tmp9_;
			gchar* _tmp10_;
#line 431 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_tmp9_ = g_strdup_printf ("status=%s", "CANCELLED");
#line 431 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_tmp10_ = _tmp9_;
#line 431 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			tee_jee_logging_log_debug (_tmp10_);
#line 431 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_g_free0 (_tmp10_);
#line 432 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			break;
#line 2025 "AsyncTask.c"
		}
#line 417 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		case APP_STATUS_PASSWORD_REQUIRED:
#line 2029 "AsyncTask.c"
		{
			gchar* _tmp11_;
			gchar* _tmp12_;
#line 434 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_tmp11_ = g_strdup_printf ("status=%s", "PASSWORD_REQUIRED");
#line 434 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_tmp12_ = _tmp11_;
#line 434 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			tee_jee_logging_log_debug (_tmp12_);
#line 434 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			_g_free0 (_tmp12_);
#line 435 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			break;
#line 2043 "AsyncTask.c"
		}
		default:
#line 417 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		break;
#line 2048 "AsyncTask.c"
	}
}


gchar*
async_task_get_stat_time_elapsed (AsyncTask* self)
{
	gchar* result;
	glong elapsed = 0L;
	GTimer* _tmp0_;
	gchar* _tmp1_;
#line 394 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 395 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_tmp0_ = self->timer;
#line 395 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	elapsed = (glong) tee_jee_system_timer_elapsed (_tmp0_, TRUE);
#line 396 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_tmp1_ = tee_jee_misc_format_duration (elapsed);
#line 396 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	result = _tmp1_;
#line 396 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	return result;
#line 2072 "AsyncTask.c"
}


gchar*
async_task_get_stat_time_remaining (AsyncTask* self)
{
	gchar* result;
	gdouble _tmp0_;
#line 401 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 402 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_tmp0_ = self->progress;
#line 402 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	if (_tmp0_ > ((gdouble) 0)) {
#line 2087 "AsyncTask.c"
		glong elapsed = 0L;
		GTimer* _tmp1_;
		glong remaining = 0L;
		glong _tmp2_;
		gdouble _tmp3_;
		gdouble _tmp4_;
		glong _tmp5_;
		glong _tmp6_;
		gchar* _tmp7_;
#line 403 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_tmp1_ = self->timer;
#line 403 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		elapsed = (glong) tee_jee_system_timer_elapsed (_tmp1_, TRUE);
#line 404 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_tmp2_ = elapsed;
#line 404 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_tmp3_ = self->progress;
#line 404 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_tmp4_ = self->progress;
#line 404 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		remaining = (glong) ((_tmp2_ / _tmp3_) * (1.0 - _tmp4_));
#line 405 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_tmp5_ = remaining;
#line 405 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		if (_tmp5_ < ((glong) 0)) {
#line 406 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
			remaining = (glong) 0;
#line 2115 "AsyncTask.c"
		}
#line 408 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_tmp6_ = remaining;
#line 408 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_tmp7_ = tee_jee_misc_format_duration (_tmp6_);
#line 408 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		result = _tmp7_;
#line 408 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		return result;
#line 2125 "AsyncTask.c"
	} else {
		gchar* _tmp8_;
#line 411 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		_tmp8_ = g_strdup ("???");
#line 411 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		result = _tmp8_;
#line 411 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		return result;
#line 2134 "AsyncTask.c"
	}
}


static void
async_task_class_init (AsyncTaskClass * klass)
{
#line 31 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	async_task_parent_class = g_type_class_peek_parent (klass);
#line 31 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	g_type_class_add_private (klass, sizeof (AsyncTaskPrivate));
#line 31 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	((AsyncTaskClass *) klass)->parse_stdout_line = (void (*) (AsyncTask *, const gchar*)) async_task_real_parse_stdout_line;
#line 31 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	((AsyncTaskClass *) klass)->parse_stderr_line = (void (*) (AsyncTask *, const gchar*)) async_task_real_parse_stderr_line;
#line 31 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	((AsyncTaskClass *) klass)->finish_task = (void (*) (AsyncTask *)) async_task_real_finish_task;
#line 31 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_async_task_get_property;
#line 31 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	G_OBJECT_CLASS (klass)->finalize = async_task_finalize;
#line 31 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ASYNC_TASK_STAT_TIME_ELAPSED_PROPERTY, async_task_properties[ASYNC_TASK_STAT_TIME_ELAPSED_PROPERTY] = g_param_spec_string ("stat-time-elapsed", "stat-time-elapsed", "stat-time-elapsed", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 31 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ASYNC_TASK_STAT_TIME_REMAINING_PROPERTY, async_task_properties[ASYNC_TASK_STAT_TIME_REMAINING_PROPERTY] = g_param_spec_string ("stat-time-remaining", "stat-time-remaining", "stat-time-remaining", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 31 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	async_task_signals[ASYNC_TASK_STDOUT_LINE_READ_SIGNAL] = g_signal_new ("stdout-line-read", TYPE_ASYNC_TASK, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
#line 31 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	async_task_signals[ASYNC_TASK_STDERR_LINE_READ_SIGNAL] = g_signal_new ("stderr-line-read", TYPE_ASYNC_TASK, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
#line 31 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	async_task_signals[ASYNC_TASK_TASK_COMPLETE_SIGNAL] = g_signal_new ("task-complete", TYPE_ASYNC_TASK, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 2166 "AsyncTask.c"
}


static void
async_task_instance_init (AsyncTask * self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
#line 31 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	self->priv = ASYNC_TASK_GET_PRIVATE (self);
#line 33 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_tmp0_ = g_strdup ("");
#line 33 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	self->priv->err_line = _tmp0_;
#line 34 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_tmp1_ = g_strdup ("");
#line 34 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	self->priv->out_line = _tmp1_;
#line 39 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	self->is_terminated = FALSE;
#line 41 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	self->priv->stdout_is_open = FALSE;
#line 42 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	self->priv->stderr_is_open = FALSE;
#line 48 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	self->priv->finish_called = FALSE;
#line 50 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_tmp2_ = g_strdup ("");
#line 50 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	self->script_file = _tmp2_;
#line 51 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_tmp3_ = g_strdup ("");
#line 51 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	self->working_dir = _tmp3_;
#line 52 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_tmp4_ = g_strdup ("");
#line 52 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	self->log_file = _tmp4_;
#line 54 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	self->background_mode = FALSE;
#line 58 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_tmp5_ = g_strdup ("");
#line 58 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	self->status_line = _tmp5_;
#line 59 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	self->exit_code = 0;
#line 60 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_tmp6_ = g_strdup ("");
#line 60 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	self->error_msg = _tmp6_;
#line 62 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	self->progress = 0.0;
#line 63 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	self->percent = 0.0;
#line 64 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	self->prg_count = (gint64) 0;
#line 65 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	self->prg_count_total = (gint64) 0;
#line 66 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	self->prg_bytes = (gint64) 0;
#line 67 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	self->prg_bytes_total = (gint64) 0;
#line 68 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_tmp7_ = g_strdup ("");
#line 68 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	self->eta = _tmp7_;
#line 2239 "AsyncTask.c"
}


static void
async_task_finalize (GObject * obj)
{
	AsyncTask * self;
#line 31 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_ASYNC_TASK, AsyncTask);
#line 33 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_g_free0 (self->priv->err_line);
#line 34 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_g_free0 (self->priv->out_line);
#line 35 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_g_object_unref0 (self->priv->dos_in);
#line 36 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_g_object_unref0 (self->priv->dis_out);
#line 37 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_g_object_unref0 (self->priv->dis_err);
#line 38 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_g_object_unref0 (self->dos_log);
#line 50 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_g_free0 (self->script_file);
#line 51 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_g_free0 (self->working_dir);
#line 52 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_g_free0 (self->log_file);
#line 58 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_g_free0 (self->status_line);
#line 60 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_g_free0 (self->error_msg);
#line 61 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_g_timer_destroy0 (self->timer);
#line 68 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	_g_free0 (self->eta);
#line 31 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	G_OBJECT_CLASS (async_task_parent_class)->finalize (obj);
#line 2277 "AsyncTask.c"
}


GType
async_task_get_type (void)
{
	static volatile gsize async_task_type_id__volatile = 0;
	if (g_once_init_enter (&async_task_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (AsyncTaskClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) async_task_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AsyncTask), 0, (GInstanceInitFunc) async_task_instance_init, NULL };
		GType async_task_type_id;
		async_task_type_id = g_type_register_static (G_TYPE_OBJECT, "AsyncTask", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&async_task_type_id__volatile, async_task_type_id);
	}
	return async_task_type_id__volatile;
}


static void
_vala_async_task_get_property (GObject * object,
                               guint property_id,
                               GValue * value,
                               GParamSpec * pspec)
{
	AsyncTask * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_ASYNC_TASK, AsyncTask);
#line 31 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
	switch (property_id) {
#line 31 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		case ASYNC_TASK_STAT_TIME_ELAPSED_PROPERTY:
#line 31 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		g_value_take_string (value, async_task_get_stat_time_elapsed (self));
#line 31 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		break;
#line 31 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		case ASYNC_TASK_STAT_TIME_REMAINING_PROPERTY:
#line 31 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		g_value_take_string (value, async_task_get_stat_time_remaining (self));
#line 31 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		break;
#line 2317 "AsyncTask.c"
		default:
#line 31 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 31 "/builddir/build/BUILD/timeshift-20.03/src/Utility/AsyncTask.vala"
		break;
#line 2323 "AsyncTask.c"
	}
}


GType
app_status_get_type (void)
{
	static volatile gsize app_status_type_id__volatile = 0;
	if (g_once_init_enter (&app_status_type_id__volatile)) {
		static const GEnumValue values[] = {{APP_STATUS_NOT_STARTED, "APP_STATUS_NOT_STARTED", "not-started"}, {APP_STATUS_RUNNING, "APP_STATUS_RUNNING", "running"}, {APP_STATUS_PAUSED, "APP_STATUS_PAUSED", "paused"}, {APP_STATUS_FINISHED, "APP_STATUS_FINISHED", "finished"}, {APP_STATUS_CANCELLED, "APP_STATUS_CANCELLED", "cancelled"}, {APP_STATUS_PASSWORD_REQUIRED, "APP_STATUS_PASSWORD_REQUIRED", "password-required"}, {0, NULL, NULL}};
		GType app_status_type_id;
		app_status_type_id = g_enum_register_static ("AppStatus", values);
		g_once_init_leave (&app_status_type_id__volatile, app_status_type_id);
	}
	return app_status_type_id__volatile;
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



