/* TeeJee.FileSystem.c generated by valac 0.40.8, the Vala compiler
 * generated from TeeJee.FileSystem.vala, do not modify */

/*
 * TeeJee.FileSystem.vala
 *
 * Copyright 2012-2018 Tony George <teejeetech@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 *
 *
 */


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <glib/gstdio.h>
#include <glib/gi18n-lib.h>
#include <gee.h>
#include <stdio.h>

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _fclose0(var) ((var == NULL) ? NULL : (var = (fclose (var), NULL)))
#define _g_checksum_free0(var) ((var == NULL) ? NULL : (var = (g_checksum_free (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))



#define TEE_JEE_FILE_SYSTEM_KB ((gint64) 1000)
#define TEE_JEE_FILE_SYSTEM_MB (1000 * TEE_JEE_FILE_SYSTEM_KB)
#define TEE_JEE_FILE_SYSTEM_GB (1000 * TEE_JEE_FILE_SYSTEM_MB)
#define TEE_JEE_FILE_SYSTEM_TB (1000 * TEE_JEE_FILE_SYSTEM_GB)
#define TEE_JEE_FILE_SYSTEM_KiB ((gint64) 1024)
#define TEE_JEE_FILE_SYSTEM_MiB (1024 * TEE_JEE_FILE_SYSTEM_KiB)
#define TEE_JEE_FILE_SYSTEM_GiB (1024 * TEE_JEE_FILE_SYSTEM_MiB)
#define TEE_JEE_FILE_SYSTEM_TiB (1024 * TEE_JEE_FILE_SYSTEM_GiB)
gchar* tee_jee_file_system_file_parent (const gchar* file_path);
gchar* tee_jee_file_system_file_basename (const gchar* file_path);
gchar* tee_jee_file_system_path_combine (const gchar* path1,
                                         const gchar* path2);
gchar* tee_jee_file_system_remove_trailing_slash (const gchar* path);
gboolean tee_jee_file_system_file_or_dir_exists (const gchar* item_path);
gboolean tee_jee_file_system_file_exists (const gchar* file_path);
gboolean tee_jee_file_system_file_exists_regular (const gchar* file_path);
gboolean tee_jee_file_system_file_delete (const gchar* file_path);
void tee_jee_logging_log_error (const gchar* message,
                                gboolean highlight,
                                gboolean is_warning);
gboolean tee_jee_file_system_file_move_to_trash (const gchar* file_path);
gchar* tee_jee_file_system_escape_single_quote (const gchar* file_path);
gboolean tee_jee_file_system_file_shred (const gchar* file_path);
gint64 tee_jee_file_system_file_line_count (const gchar* file_path);
gint tee_jee_process_helper_exec_sync (const gchar* cmd,
                                       gchar* * std_out,
                                       gchar* * std_err);
gchar* tee_jee_file_system_file_read (const gchar* file_path);
gboolean tee_jee_file_system_file_write (const gchar* file_path,
                                         const gchar* contents);
gboolean tee_jee_file_system_dir_create (const gchar* dir_path,
                                         gboolean show_message);
gboolean tee_jee_file_system_file_copy (const gchar* src_file,
                                        const gchar* dest_file);
void tee_jee_file_system_file_move (const gchar* src_file,
                                    const gchar* dest_file);
gboolean tee_jee_file_system_file_is_symlink (const gchar* file_path);
gboolean tee_jee_file_system_file_gzip (const gchar* src_file);
gboolean tee_jee_file_system_file_gunzip (const gchar* src_file);
gchar* tee_jee_file_system_file_resolve_executable_path (const gchar* file_path);
gint64 tee_jee_file_system_file_get_size (const gchar* file_path);
GDateTime* tee_jee_file_system_file_get_modified_date (const gchar* file_path);
gchar* tee_jee_file_system_file_get_symlink_target (const gchar* file_path);
gboolean tee_jee_file_system_dir_exists (const gchar* dir_path);
void tee_jee_logging_log_msg (const gchar* message,
                              gboolean highlight);
gboolean tee_jee_file_system_dir_delete (const gchar* dir_path,
                                         gboolean show_message);
void tee_jee_logging_log_debug (const gchar* message);
gboolean tee_jee_file_system_dir_move_to_trash (const gchar* dir_path);
gboolean tee_jee_file_system_dir_is_empty (const gchar* dir_path);
gboolean tee_jee_file_system_filesystem_supports_hardlinks (const gchar* path,
                                                            gboolean* is_readonly);
gchar* tee_jee_misc_random_string (gint length,
                                   const gchar* charset);
GeeArrayList* tee_jee_file_system_dir_list_names (const gchar* path);
static gint __lambda18_ (const gchar* a,
                  const gchar* b);
static gint ___lambda18__gcompare_data_func (gconstpointer a,
                                      gconstpointer b,
                                      gpointer self);
gboolean tee_jee_file_system_dir_tar (const gchar* src_dir,
                                      const gchar* tar_file,
                                      gboolean recursion);
gint tee_jee_process_helper_exec_script_sync (const gchar* script,
                                              gchar* * std_out,
                                              gchar* * std_err,
                                              gboolean supress_errors,
                                              gboolean run_as_admin,
                                              gboolean cleanup_tmp,
                                              gboolean print_to_terminal);
gboolean tee_jee_file_system_dir_untar (const gchar* tar_file,
                                        const gchar* dst_dir);
gboolean tee_jee_file_system_chown (const gchar* dir_path,
                                    const gchar* user,
                                    const gchar* group);
glong tee_jee_file_system_dir_count (const gchar* path);
glong tee_jee_file_system_dir_size (const gchar* path);
glong tee_jee_file_system_dir_size_kb (const gchar* path);
gboolean tee_jee_file_system_file_tar_encrypt (const gchar* src_file,
                                               const gchar* dst_file,
                                               const gchar* password);
gchar* tee_jee_file_system_file_decrypt_untar_read (const gchar* src_file,
                                                    const gchar* password);
gboolean tee_jee_file_system_decrypt_and_untar (const gchar* src_file,
                                                const gchar* dst_file,
                                                const gchar* password);
gchar* tee_jee_file_system_hash_md5 (const gchar* path);
gchar* tee_jee_file_system_format_file_size (guint64 size,
                                             gboolean binary_units,
                                             const gchar* unit,
                                             gboolean show_units,
                                             gint decimals);
gint tee_jee_file_system_chmod (const gchar* file,
                                const gchar* permission);
gchar* tee_jee_file_system_resolve_relative_path (const gchar* filePath);
gint tee_jee_file_system_rsync (const gchar* sourceDirectory,
                                const gchar* destDirectory,
                                gboolean updateExisting,
                                gboolean deleteExtra);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


gchar*
tee_jee_file_system_file_parent (const gchar* file_path)
{
	gchar* result = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
#line 45 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (file_path != NULL, NULL);
#line 46 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp0_ = g_file_new_for_path (file_path);
#line 46 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp1_ = _tmp0_;
#line 46 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp2_ = g_file_get_parent (_tmp1_);
#line 46 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp3_ = _tmp2_;
#line 46 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp4_ = g_file_get_path (_tmp3_);
#line 46 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp5_ = _tmp4_;
#line 46 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_g_object_unref0 (_tmp3_);
#line 46 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_g_object_unref0 (_tmp1_);
#line 46 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	result = _tmp5_;
#line 46 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	return result;
#line 190 "TeeJee.FileSystem.c"
}


gchar*
tee_jee_file_system_file_basename (const gchar* file_path)
{
	gchar* result = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 49 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (file_path != NULL, NULL);
#line 50 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp0_ = g_file_new_for_path (file_path);
#line 50 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp1_ = _tmp0_;
#line 50 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp2_ = g_file_get_basename (_tmp1_);
#line 50 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp3_ = _tmp2_;
#line 50 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_g_object_unref0 (_tmp1_);
#line 50 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	result = _tmp3_;
#line 50 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	return result;
#line 218 "TeeJee.FileSystem.c"
}


gchar*
tee_jee_file_system_path_combine (const gchar* path1,
                                  const gchar* path2)
{
	gchar* result = NULL;
	gchar* _tmp0_;
#line 53 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (path1 != NULL, NULL);
#line 53 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (path2 != NULL, NULL);
#line 54 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp0_ = g_build_path ("/", path1, path2, NULL);
#line 54 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	result = _tmp0_;
#line 54 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	return result;
#line 238 "TeeJee.FileSystem.c"
}


static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	gchar* result = NULL;
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gchar* _tmp8_;
#line 1369 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1370 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1370 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1370 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1371 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 264 "TeeJee.FileSystem.c"
		glong _tmp2_;
#line 1372 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp2_ = string_length;
#line 1372 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		start = _tmp2_ + start;
#line 270 "TeeJee.FileSystem.c"
	}
#line 1374 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 274 "TeeJee.FileSystem.c"
		glong _tmp3_;
#line 1375 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp3_ = string_length;
#line 1375 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		end = _tmp3_ + end;
#line 280 "TeeJee.FileSystem.c"
	}
#line 1377 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 284 "TeeJee.FileSystem.c"
		glong _tmp5_;
#line 1377 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp5_ = string_length;
#line 1377 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp4_ = start <= _tmp5_;
#line 290 "TeeJee.FileSystem.c"
	} else {
#line 1377 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp4_ = FALSE;
#line 294 "TeeJee.FileSystem.c"
	}
#line 1377 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (_tmp4_, NULL);
#line 1378 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 300 "TeeJee.FileSystem.c"
		glong _tmp7_;
#line 1378 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp7_ = string_length;
#line 1378 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp6_ = end <= _tmp7_;
#line 306 "TeeJee.FileSystem.c"
	} else {
#line 1378 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp6_ = FALSE;
#line 310 "TeeJee.FileSystem.c"
	}
#line 1378 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (_tmp6_, NULL);
#line 1379 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1380 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp8_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
#line 1380 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	result = _tmp8_;
#line 1380 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	return result;
#line 322 "TeeJee.FileSystem.c"
}


gchar*
tee_jee_file_system_remove_trailing_slash (const gchar* path)
{
	gchar* result = NULL;
#line 57 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 58 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	if (g_str_has_suffix (path, "/")) {
#line 334 "TeeJee.FileSystem.c"
		gint _tmp0_;
		gint _tmp1_;
		gchar* _tmp2_;
#line 59 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp0_ = strlen (path);
#line 59 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp1_ = _tmp0_;
#line 59 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp2_ = string_slice (path, (glong) 0, (glong) (_tmp1_ - 1));
#line 59 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		result = _tmp2_;
#line 59 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		return result;
#line 348 "TeeJee.FileSystem.c"
	} else {
		gchar* _tmp3_;
#line 62 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp3_ = g_strdup (path);
#line 62 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		result = _tmp3_;
#line 62 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		return result;
#line 357 "TeeJee.FileSystem.c"
	}
}


gboolean
tee_jee_file_system_file_or_dir_exists (const gchar* item_path)
{
	gboolean result = FALSE;
	GFile* item = NULL;
	GFile* _tmp0_;
#line 68 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (item_path != NULL, FALSE);
#line 72 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp0_ = g_file_parse_name (item_path);
#line 72 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	item = _tmp0_;
#line 73 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	result = g_file_query_exists (item, NULL);
#line 73 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_g_object_unref0 (item);
#line 73 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	return result;
#line 380 "TeeJee.FileSystem.c"
}


gboolean
tee_jee_file_system_file_exists (const gchar* file_path)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 76 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (file_path != NULL, FALSE);
#line 78 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	if (g_file_test (file_path, G_FILE_TEST_EXISTS)) {
#line 79 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp0_ = !g_file_test (file_path, G_FILE_TEST_IS_DIR);
#line 395 "TeeJee.FileSystem.c"
	} else {
#line 78 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp0_ = FALSE;
#line 399 "TeeJee.FileSystem.c"
	}
#line 78 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	result = _tmp0_;
#line 78 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	return result;
#line 405 "TeeJee.FileSystem.c"
}


gboolean
tee_jee_file_system_file_exists_regular (const gchar* file_path)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 82 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (file_path != NULL, FALSE);
#line 84 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	if (g_file_test (file_path, G_FILE_TEST_EXISTS)) {
#line 85 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp0_ = g_file_test (file_path, G_FILE_TEST_IS_REGULAR);
#line 420 "TeeJee.FileSystem.c"
	} else {
#line 84 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp0_ = FALSE;
#line 424 "TeeJee.FileSystem.c"
	}
#line 84 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	result = _tmp0_;
#line 84 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	return result;
#line 430 "TeeJee.FileSystem.c"
}


gboolean
tee_jee_file_system_file_delete (const gchar* file_path)
{
	gboolean result = FALSE;
	gboolean _tmp9_ = FALSE;
	GError * _inner_error_ = NULL;
#line 88 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (file_path != NULL, FALSE);
#line 442 "TeeJee.FileSystem.c"
	{
		GFile* file = NULL;
		GFile* _tmp0_;
		GFile* _tmp1_;
#line 93 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp0_ = g_file_new_for_path (file_path);
#line 93 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		file = _tmp0_;
#line 94 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp1_ = file;
#line 94 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		if (g_file_query_exists (_tmp1_, NULL)) {
#line 455 "TeeJee.FileSystem.c"
			GFile* _tmp2_;
#line 95 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp2_ = file;
#line 95 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			g_file_delete (_tmp2_, NULL, &_inner_error_);
#line 95 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 95 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (file);
#line 465 "TeeJee.FileSystem.c"
				goto __catch64_g_error;
			}
		}
#line 97 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		result = TRUE;
#line 97 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_object_unref0 (file);
#line 97 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		return result;
#line 475 "TeeJee.FileSystem.c"
	}
	goto __finally64;
	__catch64_g_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
#line 92 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		e = _inner_error_;
#line 92 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_inner_error_ = NULL;
#line 99 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp3_ = e;
#line 99 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp4_ = _tmp3_->message;
#line 99 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp4_, FALSE, FALSE);
#line 100 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp5_ = g_strdup_printf (": %s", file_path);
#line 100 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp6_ = _tmp5_;
#line 100 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp7_ = g_strconcat (_ ("Failed to delete file"), _tmp6_, NULL);
#line 100 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp8_ = _tmp7_;
#line 100 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp8_, FALSE, FALSE);
#line 100 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp8_);
#line 100 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp6_);
#line 101 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		result = FALSE;
#line 101 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_error_free0 (e);
#line 101 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		return result;
#line 517 "TeeJee.FileSystem.c"
	}
	__finally64:
#line 92 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 92 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	g_clear_error (&_inner_error_);
#line 92 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	return _tmp9_;
#line 526 "TeeJee.FileSystem.c"
}


gboolean
tee_jee_file_system_file_move_to_trash (const gchar* file_path)
{
	gboolean result = FALSE;
	GFile* file = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
#line 105 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (file_path != NULL, FALSE);
#line 109 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp0_ = g_file_new_for_path (file_path);
#line 109 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	file = _tmp0_;
#line 110 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp1_ = file;
#line 110 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	if (g_file_query_exists (_tmp1_, NULL)) {
#line 547 "TeeJee.FileSystem.c"
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
#line 111 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp2_ = tee_jee_file_system_escape_single_quote (file_path);
#line 111 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp3_ = _tmp2_;
#line 111 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp4_ = g_strdup_printf ("gvfs-trash '%s'", _tmp3_);
#line 111 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp5_ = _tmp4_;
#line 111 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		system (_tmp5_);
#line 111 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp5_);
#line 111 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp3_);
#line 566 "TeeJee.FileSystem.c"
	}
#line 113 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	result = TRUE;
#line 113 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_g_object_unref0 (file);
#line 113 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	return result;
#line 574 "TeeJee.FileSystem.c"
}


gboolean
tee_jee_file_system_file_shred (const gchar* file_path)
{
	gboolean result = FALSE;
	GFile* file = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
#line 116 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (file_path != NULL, FALSE);
#line 120 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp0_ = g_file_new_for_path (file_path);
#line 120 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	file = _tmp0_;
#line 121 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp1_ = file;
#line 121 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	if (g_file_query_exists (_tmp1_, NULL)) {
#line 595 "TeeJee.FileSystem.c"
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
#line 122 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp2_ = tee_jee_file_system_escape_single_quote (file_path);
#line 122 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp3_ = _tmp2_;
#line 122 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp4_ = g_strdup_printf ("shred -u '%s'", _tmp3_);
#line 122 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp5_ = _tmp4_;
#line 122 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		system (_tmp5_);
#line 122 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp5_);
#line 122 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp3_);
#line 614 "TeeJee.FileSystem.c"
	}
#line 124 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	result = TRUE;
#line 124 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_g_object_unref0 (file);
#line 124 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	return result;
#line 622 "TeeJee.FileSystem.c"
}


gint64
tee_jee_file_system_file_line_count (const gchar* file_path)
{
	gint64 result = 0LL;
	gchar* cmd = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	gchar** _tmp6_;
	gchar** _tmp7_;
	gchar** _tmp8_;
	gint _tmp8__length1;
	const gchar* _tmp9_;
	gint64 _tmp10_;
#line 127 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (file_path != NULL, 0LL);
#line 129 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp0_ = tee_jee_file_system_escape_single_quote (file_path);
#line 129 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp1_ = _tmp0_;
#line 129 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp2_ = g_strdup_printf ("wc -l '%s'", _tmp1_);
#line 129 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp3_ = _tmp2_;
#line 129 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (_tmp1_);
#line 129 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	cmd = _tmp3_;
#line 131 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	tee_jee_process_helper_exec_sync (cmd, &_tmp4_, &_tmp5_);
#line 131 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_out);
#line 131 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	std_out = _tmp4_;
#line 131 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_err);
#line 131 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	std_err = _tmp5_;
#line 132 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp7_ = _tmp6_ = g_strsplit (std_out, "\t", 0);
#line 132 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp8_ = _tmp7_;
#line 132 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp8__length1 = _vala_array_length (_tmp6_);
#line 132 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp9_ = _tmp8_[0];
#line 132 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp10_ = (gint64) atol (_tmp9_);
#line 132 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp8_ = (_vala_array_free (_tmp8_, _tmp8__length1, (GDestroyNotify) g_free), NULL);
#line 132 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	result = _tmp10_;
#line 132 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_err);
#line 132 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_out);
#line 132 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (cmd);
#line 132 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	return result;
#line 691 "TeeJee.FileSystem.c"
}


gchar*
tee_jee_file_system_file_read (const gchar* file_path)
{
	gchar* result = NULL;
	gchar* txt = NULL;
	gsize size = 0UL;
	GError * _inner_error_ = NULL;
#line 135 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (file_path != NULL, NULL);
#line 704 "TeeJee.FileSystem.c"
	{
		gchar* _tmp0_ = NULL;
		gsize _tmp1_ = 0UL;
#line 143 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		g_file_get_contents (file_path, &_tmp0_, &_tmp1_, &_inner_error_);
#line 143 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (txt);
#line 143 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		txt = _tmp0_;
#line 143 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		size = _tmp1_;
#line 143 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 718 "TeeJee.FileSystem.c"
			goto __catch65_g_error;
		}
#line 144 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		result = txt;
#line 144 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		return result;
#line 725 "TeeJee.FileSystem.c"
	}
	goto __finally65;
	__catch65_g_error:
	{
		GError* e = NULL;
		GError* _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
#line 142 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		e = _inner_error_;
#line 142 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_inner_error_ = NULL;
#line 147 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp2_ = e;
#line 147 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp3_ = _tmp2_->message;
#line 147 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp3_, FALSE, FALSE);
#line 148 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp4_ = g_strdup_printf (": %s", file_path);
#line 148 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp5_ = _tmp4_;
#line 148 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp6_ = g_strconcat (_ ("Failed to read file"), _tmp5_, NULL);
#line 148 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp7_ = _tmp6_;
#line 148 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp7_, FALSE, FALSE);
#line 148 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp7_);
#line 148 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp5_);
#line 142 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_error_free0 (e);
#line 763 "TeeJee.FileSystem.c"
	}
	__finally65:
#line 142 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 142 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (txt);
#line 142 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 142 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		g_clear_error (&_inner_error_);
#line 142 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		return NULL;
#line 776 "TeeJee.FileSystem.c"
	}
#line 151 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	result = NULL;
#line 151 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (txt);
#line 151 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	return result;
#line 784 "TeeJee.FileSystem.c"
}


gboolean
tee_jee_file_system_file_write (const gchar* file_path,
                                const gchar* contents)
{
	gboolean result = FALSE;
	gboolean _tmp17_ = FALSE;
	GError * _inner_error_ = NULL;
#line 154 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (file_path != NULL, FALSE);
#line 154 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (contents != NULL, FALSE);
#line 799 "TeeJee.FileSystem.c"
	{
		gchar* _tmp0_;
		gchar* _tmp1_;
		GFile* file = NULL;
		GFile* _tmp2_;
		GFile* _tmp3_;
		GFileOutputStream* file_stream = NULL;
		GFile* _tmp5_;
		GFileOutputStream* _tmp6_;
		GDataOutputStream* data_stream = NULL;
		GFileOutputStream* _tmp7_;
		GDataOutputStream* _tmp8_;
		GDataOutputStream* _tmp9_;
		GDataOutputStream* _tmp10_;
#line 160 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp0_ = tee_jee_file_system_file_parent (file_path);
#line 160 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp1_ = _tmp0_;
#line 160 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		tee_jee_file_system_dir_create (_tmp1_, FALSE);
#line 160 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp1_);
#line 162 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp2_ = g_file_new_for_path (file_path);
#line 162 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		file = _tmp2_;
#line 163 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp3_ = file;
#line 163 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		if (g_file_query_exists (_tmp3_, NULL)) {
#line 830 "TeeJee.FileSystem.c"
			GFile* _tmp4_;
#line 164 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp4_ = file;
#line 164 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			g_file_delete (_tmp4_, NULL, &_inner_error_);
#line 164 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 164 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (file);
#line 840 "TeeJee.FileSystem.c"
				goto __catch66_g_error;
			}
		}
#line 167 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp5_ = file;
#line 167 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp6_ = g_file_create (_tmp5_, G_FILE_CREATE_REPLACE_DESTINATION, NULL, &_inner_error_);
#line 167 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		file_stream = _tmp6_;
#line 167 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 167 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (file);
#line 854 "TeeJee.FileSystem.c"
			goto __catch66_g_error;
		}
#line 168 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp7_ = file_stream;
#line 168 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp8_ = g_data_output_stream_new ((GOutputStream*) _tmp7_);
#line 168 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		data_stream = _tmp8_;
#line 169 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp9_ = data_stream;
#line 169 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		g_data_output_stream_put_string (_tmp9_, contents, NULL, &_inner_error_);
#line 169 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 169 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (data_stream);
#line 169 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (file_stream);
#line 169 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (file);
#line 875 "TeeJee.FileSystem.c"
			goto __catch66_g_error;
		}
#line 170 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp10_ = data_stream;
#line 170 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		g_output_stream_close ((GOutputStream*) _tmp10_, NULL, &_inner_error_);
#line 170 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 170 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (data_stream);
#line 170 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (file_stream);
#line 170 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (file);
#line 890 "TeeJee.FileSystem.c"
			goto __catch66_g_error;
		}
#line 171 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		result = TRUE;
#line 171 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_object_unref0 (data_stream);
#line 171 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_object_unref0 (file_stream);
#line 171 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_object_unref0 (file);
#line 171 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		return result;
#line 903 "TeeJee.FileSystem.c"
	}
	goto __finally66;
	__catch66_g_error:
	{
		GError* e = NULL;
		GError* _tmp11_;
		const gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
#line 158 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		e = _inner_error_;
#line 158 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_inner_error_ = NULL;
#line 174 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp11_ = e;
#line 174 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp12_ = _tmp11_->message;
#line 174 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp12_, FALSE, FALSE);
#line 175 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp13_ = g_strdup_printf (": %s", file_path);
#line 175 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp14_ = _tmp13_;
#line 175 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp15_ = g_strconcat (_ ("Failed to write file"), _tmp14_, NULL);
#line 175 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp16_ = _tmp15_;
#line 175 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp16_, FALSE, FALSE);
#line 175 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp16_);
#line 175 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp14_);
#line 176 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		result = FALSE;
#line 176 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_error_free0 (e);
#line 176 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		return result;
#line 945 "TeeJee.FileSystem.c"
	}
	__finally66:
#line 158 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 158 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	g_clear_error (&_inner_error_);
#line 158 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	return _tmp17_;
#line 954 "TeeJee.FileSystem.c"
}


gboolean
tee_jee_file_system_file_copy (const gchar* src_file,
                               const gchar* dest_file)
{
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 180 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (src_file != NULL, FALSE);
#line 180 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (dest_file != NULL, FALSE);
#line 968 "TeeJee.FileSystem.c"
	{
		GFile* file_src = NULL;
		GFile* _tmp0_;
		GFile* _tmp1_;
#line 182 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp0_ = g_file_new_for_path (src_file);
#line 182 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		file_src = _tmp0_;
#line 183 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp1_ = file_src;
#line 183 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		if (g_file_query_exists (_tmp1_, NULL)) {
#line 981 "TeeJee.FileSystem.c"
			GFile* file_dest = NULL;
			GFile* _tmp2_;
			GFile* _tmp3_;
			GFile* _tmp4_;
#line 184 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp2_ = g_file_new_for_path (dest_file);
#line 184 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			file_dest = _tmp2_;
#line 185 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp3_ = file_src;
#line 185 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp4_ = file_dest;
#line 185 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			g_file_copy (_tmp3_, _tmp4_, G_FILE_COPY_OVERWRITE, NULL, NULL, NULL, &_inner_error_);
#line 185 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 185 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (file_dest);
#line 185 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (file_src);
#line 1002 "TeeJee.FileSystem.c"
				goto __catch67_g_error;
			}
#line 186 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			result = TRUE;
#line 186 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (file_dest);
#line 186 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (file_src);
#line 186 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			return result;
#line 1013 "TeeJee.FileSystem.c"
		}
#line 181 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_object_unref0 (file_src);
#line 1017 "TeeJee.FileSystem.c"
	}
	goto __finally67;
	__catch67_g_error:
	{
		GError* e = NULL;
		GError* _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 181 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		e = _inner_error_;
#line 181 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_inner_error_ = NULL;
#line 190 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp5_ = e;
#line 190 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp6_ = _tmp5_->message;
#line 190 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp6_, FALSE, FALSE);
#line 191 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp7_ = g_strdup_printf (": '%s', '%s'", src_file, dest_file);
#line 191 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp8_ = _tmp7_;
#line 191 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp9_ = g_strconcat (_ ("Failed to copy file"), _tmp8_, NULL);
#line 191 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp10_ = _tmp9_;
#line 191 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp10_, FALSE, FALSE);
#line 191 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp10_);
#line 191 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp8_);
#line 181 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_error_free0 (e);
#line 1055 "TeeJee.FileSystem.c"
	}
	__finally67:
#line 181 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1060 "TeeJee.FileSystem.c"
		gboolean _tmp11_ = FALSE;
#line 181 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 181 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		g_clear_error (&_inner_error_);
#line 181 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		return _tmp11_;
#line 1068 "TeeJee.FileSystem.c"
	}
#line 194 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	result = FALSE;
#line 194 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	return result;
#line 1074 "TeeJee.FileSystem.c"
}


void
tee_jee_file_system_file_move (const gchar* src_file,
                               const gchar* dest_file)
{
	GError * _inner_error_ = NULL;
#line 197 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	g_return_if_fail (src_file != NULL);
#line 197 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	g_return_if_fail (dest_file != NULL);
#line 1087 "TeeJee.FileSystem.c"
	{
		GFile* file_src = NULL;
		GFile* _tmp0_;
		GFile* _tmp1_;
#line 199 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp0_ = g_file_new_for_path (src_file);
#line 199 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		file_src = _tmp0_;
#line 200 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp1_ = file_src;
#line 200 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		if (g_file_query_exists (_tmp1_, NULL)) {
#line 1100 "TeeJee.FileSystem.c"
			GFile* file_dest = NULL;
			GFile* _tmp2_;
			GFile* _tmp3_;
			GFile* _tmp4_;
#line 201 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp2_ = g_file_new_for_path (dest_file);
#line 201 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			file_dest = _tmp2_;
#line 202 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp3_ = file_src;
#line 202 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp4_ = file_dest;
#line 202 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			g_file_move (_tmp3_, _tmp4_, G_FILE_COPY_OVERWRITE, NULL, NULL, NULL, &_inner_error_);
#line 202 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 202 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (file_dest);
#line 202 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (file_src);
#line 1121 "TeeJee.FileSystem.c"
				goto __catch68_g_error;
			}
#line 200 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (file_dest);
#line 1126 "TeeJee.FileSystem.c"
		} else {
			gchar* _tmp5_;
			gchar* _tmp6_;
			gchar* _tmp7_;
			gchar* _tmp8_;
#line 205 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp5_ = g_strdup_printf (": '%s'", src_file);
#line 205 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp6_ = _tmp5_;
#line 205 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp7_ = g_strconcat (_ ("File not found"), _tmp6_, NULL);
#line 205 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp8_ = _tmp7_;
#line 205 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			tee_jee_logging_log_error (_tmp8_, FALSE, FALSE);
#line 205 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (_tmp8_);
#line 205 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (_tmp6_);
#line 1146 "TeeJee.FileSystem.c"
		}
#line 198 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_object_unref0 (file_src);
#line 1150 "TeeJee.FileSystem.c"
	}
	goto __finally68;
	__catch68_g_error:
	{
		GError* e = NULL;
		GError* _tmp9_;
		const gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
#line 198 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		e = _inner_error_;
#line 198 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_inner_error_ = NULL;
#line 209 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp9_ = e;
#line 209 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp10_ = _tmp9_->message;
#line 209 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp10_, FALSE, FALSE);
#line 210 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp11_ = g_strdup_printf (": '%s', '%s'", src_file, dest_file);
#line 210 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp12_ = _tmp11_;
#line 210 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp13_ = g_strconcat (_ ("Failed to move file"), _tmp12_, NULL);
#line 210 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp14_ = _tmp13_;
#line 210 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp14_, FALSE, FALSE);
#line 210 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp14_);
#line 210 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp12_);
#line 198 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_error_free0 (e);
#line 1188 "TeeJee.FileSystem.c"
	}
	__finally68:
#line 198 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 198 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 198 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		g_clear_error (&_inner_error_);
#line 198 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		return;
#line 1199 "TeeJee.FileSystem.c"
	}
}


gboolean
tee_jee_file_system_file_is_symlink (const gchar* file_path)
{
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 214 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (file_path != NULL, FALSE);
#line 1211 "TeeJee.FileSystem.c"
	{
		GFile* file = NULL;
		GFile* _tmp0_;
		GFile* _tmp1_;
#line 217 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp0_ = g_file_new_for_path (file_path);
#line 217 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		file = _tmp0_;
#line 219 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp1_ = file;
#line 219 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		if (g_file_query_exists (_tmp1_, NULL)) {
#line 1224 "TeeJee.FileSystem.c"
			GFileInfo* info = NULL;
			GFile* _tmp2_;
			gchar* _tmp3_;
			gchar* _tmp4_;
			GFileInfo* _tmp5_;
			GFileInfo* _tmp6_;
			GFileType file_type = 0;
			GFileInfo* _tmp7_;
			GFileType _tmp8_;
#line 221 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp2_ = file;
#line 221 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp3_ = g_strdup_printf ("%s", G_FILE_ATTRIBUTE_STANDARD_TYPE);
#line 221 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp4_ = _tmp3_;
#line 221 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp5_ = g_file_query_info (_tmp2_, _tmp4_, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error_);
#line 221 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp6_ = _tmp5_;
#line 221 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (_tmp4_);
#line 221 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			info = _tmp6_;
#line 221 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 221 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (file);
#line 1252 "TeeJee.FileSystem.c"
				goto __catch69_g_error;
			}
#line 223 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp7_ = info;
#line 223 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			file_type = g_file_info_get_file_type (_tmp7_);
#line 225 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp8_ = file_type;
#line 225 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			result = _tmp8_ == G_FILE_TYPE_SYMBOLIC_LINK;
#line 225 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (info);
#line 225 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (file);
#line 225 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			return result;
#line 1269 "TeeJee.FileSystem.c"
		}
#line 216 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_object_unref0 (file);
#line 1273 "TeeJee.FileSystem.c"
	}
	goto __finally69;
	__catch69_g_error:
	{
		GError* e = NULL;
		GError* _tmp9_;
		const gchar* _tmp10_;
#line 216 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		e = _inner_error_;
#line 216 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_inner_error_ = NULL;
#line 229 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp9_ = e;
#line 229 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp10_ = _tmp9_->message;
#line 229 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp10_, FALSE, FALSE);
#line 216 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_error_free0 (e);
#line 1293 "TeeJee.FileSystem.c"
	}
	__finally69:
#line 216 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1298 "TeeJee.FileSystem.c"
		gboolean _tmp11_ = FALSE;
#line 216 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 216 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		g_clear_error (&_inner_error_);
#line 216 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		return _tmp11_;
#line 1306 "TeeJee.FileSystem.c"
	}
#line 232 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	result = FALSE;
#line 232 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	return result;
#line 1312 "TeeJee.FileSystem.c"
}


gboolean
tee_jee_file_system_file_gzip (const gchar* src_file)
{
	gboolean result = FALSE;
	gchar* dst_file = NULL;
	gchar* _tmp0_;
	gchar* cmd = NULL;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
#line 235 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (src_file != NULL, FALSE);
#line 237 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp0_ = g_strconcat (src_file, ".gz", NULL);
#line 237 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	dst_file = _tmp0_;
#line 238 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	tee_jee_file_system_file_delete (dst_file);
#line 240 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp1_ = tee_jee_file_system_escape_single_quote (src_file);
#line 240 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp2_ = _tmp1_;
#line 240 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp3_ = g_strdup_printf ("gzip '%s'", _tmp2_);
#line 240 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp4_ = _tmp3_;
#line 240 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (_tmp2_);
#line 240 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	cmd = _tmp4_;
#line 242 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	tee_jee_process_helper_exec_sync (cmd, &_tmp5_, &_tmp6_);
#line 242 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_out);
#line 242 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	std_out = _tmp5_;
#line 242 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_err);
#line 242 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	std_err = _tmp6_;
#line 244 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	result = tee_jee_file_system_file_exists (dst_file);
#line 244 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_err);
#line 244 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_out);
#line 244 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (cmd);
#line 244 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (dst_file);
#line 244 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	return result;
#line 1373 "TeeJee.FileSystem.c"
}


gboolean
tee_jee_file_system_file_gunzip (const gchar* src_file)
{
	gboolean result = FALSE;
	gchar* dst_file = NULL;
	gchar* _tmp0_;
	gchar* cmd = NULL;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
#line 247 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (src_file != NULL, FALSE);
#line 249 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp0_ = g_strdup (src_file);
#line 249 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	dst_file = _tmp0_;
#line 250 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	tee_jee_file_system_file_delete (dst_file);
#line 252 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp1_ = tee_jee_file_system_escape_single_quote (src_file);
#line 252 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp2_ = _tmp1_;
#line 252 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp3_ = g_strdup_printf ("gunzip '%s'", _tmp2_);
#line 252 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp4_ = _tmp3_;
#line 252 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (_tmp2_);
#line 252 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	cmd = _tmp4_;
#line 254 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	tee_jee_process_helper_exec_sync (cmd, &_tmp5_, &_tmp6_);
#line 254 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_out);
#line 254 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	std_out = _tmp5_;
#line 254 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_err);
#line 254 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	std_err = _tmp6_;
#line 256 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	result = tee_jee_file_system_file_exists (dst_file);
#line 256 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_err);
#line 256 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_out);
#line 256 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (cmd);
#line 256 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (dst_file);
#line 256 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	return result;
#line 1434 "TeeJee.FileSystem.c"
}


static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gboolean result = FALSE;
	gchar* _tmp0_;
#line 1417 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1417 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1418 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1418 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1418 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	return result;
#line 1454 "TeeJee.FileSystem.c"
}


gchar*
tee_jee_file_system_file_resolve_executable_path (const gchar* file_path)
{
	gchar* result = NULL;
#line 259 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (file_path != NULL, NULL);
#line 261 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	if (g_str_has_prefix (file_path, "/")) {
#line 1466 "TeeJee.FileSystem.c"
		gchar* _tmp0_;
#line 262 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp0_ = g_strdup (file_path);
#line 262 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		result = _tmp0_;
#line 262 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		return result;
#line 1474 "TeeJee.FileSystem.c"
	} else {
#line 264 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		if (!string_contains (file_path, "/")) {
#line 1478 "TeeJee.FileSystem.c"
			gchar* _tmp1_;
#line 265 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp1_ = g_find_program_in_path (file_path);
#line 265 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			result = _tmp1_;
#line 265 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			return result;
#line 1486 "TeeJee.FileSystem.c"
		} else {
#line 267 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			if (g_str_has_prefix (file_path, "./")) {
#line 1490 "TeeJee.FileSystem.c"
				gchar* _tmp2_;
				gchar* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
				gchar* _tmp6_;
				gchar* _tmp7_;
				gchar* _tmp8_;
				gchar* _tmp9_;
#line 268 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
				_tmp2_ = g_get_current_dir ();
#line 268 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
				_tmp3_ = _tmp2_;
#line 268 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
				_tmp4_ = strlen (file_path);
#line 268 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
				_tmp5_ = _tmp4_;
#line 268 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
				_tmp6_ = string_slice (file_path, (glong) 2, (glong) _tmp5_);
#line 268 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
				_tmp7_ = _tmp6_;
#line 268 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
				_tmp8_ = tee_jee_file_system_path_combine (_tmp3_, _tmp7_);
#line 268 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
				_tmp9_ = _tmp8_;
#line 268 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
				_g_free0 (_tmp7_);
#line 268 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
				_g_free0 (_tmp3_);
#line 268 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
				result = _tmp9_;
#line 268 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
				return result;
#line 1523 "TeeJee.FileSystem.c"
			} else {
#line 270 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
				if (g_str_has_prefix (file_path, "../")) {
#line 1527 "TeeJee.FileSystem.c"
					gchar* _tmp10_;
					gchar* _tmp11_;
					gchar* _tmp12_;
					gchar* _tmp13_;
					gint _tmp14_;
					gint _tmp15_;
					gchar* _tmp16_;
					gchar* _tmp17_;
					gchar* _tmp18_;
					gchar* _tmp19_;
#line 271 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
					_tmp10_ = g_get_current_dir ();
#line 271 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
					_tmp11_ = _tmp10_;
#line 271 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
					_tmp12_ = tee_jee_file_system_file_parent (_tmp11_);
#line 271 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
					_tmp13_ = _tmp12_;
#line 271 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
					_tmp14_ = strlen (file_path);
#line 271 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
					_tmp15_ = _tmp14_;
#line 271 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
					_tmp16_ = string_slice (file_path, (glong) 3, (glong) _tmp15_);
#line 271 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
					_tmp17_ = _tmp16_;
#line 271 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
					_tmp18_ = tee_jee_file_system_path_combine (_tmp13_, _tmp17_);
#line 271 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
					_tmp19_ = _tmp18_;
#line 271 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
					_g_free0 (_tmp17_);
#line 271 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
					_g_free0 (_tmp13_);
#line 271 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
					_g_free0 (_tmp11_);
#line 271 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
					result = _tmp19_;
#line 271 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
					return result;
#line 1568 "TeeJee.FileSystem.c"
				} else {
					gchar* _tmp20_;
					gchar* _tmp21_;
					gchar* _tmp22_;
					gchar* _tmp23_;
#line 274 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
					_tmp20_ = g_get_current_dir ();
#line 274 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
					_tmp21_ = _tmp20_;
#line 274 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
					_tmp22_ = tee_jee_file_system_path_combine (_tmp21_, file_path);
#line 274 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
					_tmp23_ = _tmp22_;
#line 274 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
					_g_free0 (_tmp21_);
#line 274 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
					result = _tmp23_;
#line 274 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
					return result;
#line 1588 "TeeJee.FileSystem.c"
				}
			}
		}
	}
}


gint64
tee_jee_file_system_file_get_size (const gchar* file_path)
{
	gint64 result = 0LL;
	GError * _inner_error_ = NULL;
#line 280 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (file_path != NULL, 0LL);
#line 1603 "TeeJee.FileSystem.c"
	{
		GFile* file = NULL;
		GFile* _tmp0_;
#line 284 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp0_ = g_file_parse_name (file_path);
#line 284 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		file = _tmp0_;
#line 286 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		if (g_file_test (file_path, G_FILE_TEST_EXISTS)) {
#line 1613 "TeeJee.FileSystem.c"
			gboolean _tmp1_ = FALSE;
#line 288 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			if (g_file_test (file_path, G_FILE_TEST_IS_REGULAR)) {
#line 289 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
				_tmp1_ = !g_file_test (file_path, G_FILE_TEST_IS_SYMLINK);
#line 1619 "TeeJee.FileSystem.c"
			} else {
#line 288 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
				_tmp1_ = FALSE;
#line 1623 "TeeJee.FileSystem.c"
			}
#line 288 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			if (_tmp1_) {
#line 1627 "TeeJee.FileSystem.c"
				GFileInfo* _tmp2_ = NULL;
				GFile* _tmp3_;
				GFileInfo* _tmp4_;
#line 291 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
				_tmp3_ = file;
#line 291 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
				_tmp4_ = g_file_query_info (_tmp3_, "standard::size", 0, NULL, &_inner_error_);
#line 291 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
				_tmp2_ = _tmp4_;
#line 291 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 291 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
					_g_object_unref0 (file);
#line 1641 "TeeJee.FileSystem.c"
					goto __catch70_g_error;
				}
#line 291 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
				result = g_file_info_get_size (_tmp2_);
#line 291 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (_tmp2_);
#line 291 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (file);
#line 291 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
				return result;
#line 1652 "TeeJee.FileSystem.c"
			}
		}
#line 282 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_object_unref0 (file);
#line 1657 "TeeJee.FileSystem.c"
	}
	goto __finally70;
	__catch70_g_error:
	{
		GError* e = NULL;
		GError* _tmp5_;
		const gchar* _tmp6_;
#line 282 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		e = _inner_error_;
#line 282 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_inner_error_ = NULL;
#line 296 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp5_ = e;
#line 296 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp6_ = _tmp5_->message;
#line 296 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp6_, FALSE, FALSE);
#line 282 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_error_free0 (e);
#line 1677 "TeeJee.FileSystem.c"
	}
	__finally70:
#line 282 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1682 "TeeJee.FileSystem.c"
		gint64 _tmp7_ = -1LL;
#line 282 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 282 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		g_clear_error (&_inner_error_);
#line 282 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		return _tmp7_;
#line 1690 "TeeJee.FileSystem.c"
	}
#line 299 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	result = (gint64) -1;
#line 299 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	return result;
#line 1696 "TeeJee.FileSystem.c"
}


GDateTime*
tee_jee_file_system_file_get_modified_date (const gchar* file_path)
{
	GDateTime* result = NULL;
	GDateTime* _tmp17_;
	GError * _inner_error_ = NULL;
#line 302 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (file_path != NULL, NULL);
#line 1708 "TeeJee.FileSystem.c"
	{
		GFileInfo* info = NULL;
		GFile* file = NULL;
		GFile* _tmp0_;
		GFile* _tmp1_;
#line 305 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp0_ = g_file_parse_name (file_path);
#line 305 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		file = _tmp0_;
#line 306 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp1_ = file;
#line 306 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		if (g_file_query_exists (_tmp1_, NULL)) {
#line 1722 "TeeJee.FileSystem.c"
			GFileInfo* _tmp2_ = NULL;
			GFile* _tmp3_;
			gchar* _tmp4_;
			gchar* _tmp5_;
			GFileInfo* _tmp6_;
			GFileInfo* _tmp7_;
			GFileInfo* _tmp8_;
			GFileInfo* _tmp9_;
			GTimeVal _tmp10_ = {0};
			GDateTime* _tmp11_;
			GDateTime* _tmp12_;
			GDateTime* _tmp13_;
			GDateTime* _tmp14_;
#line 307 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp3_ = file;
#line 307 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp4_ = g_strdup_printf ("%s", G_FILE_ATTRIBUTE_TIME_MODIFIED);
#line 307 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp5_ = _tmp4_;
#line 307 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp6_ = g_file_query_info (_tmp3_, _tmp5_, 0, NULL, &_inner_error_);
#line 307 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp7_ = _tmp6_;
#line 307 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (_tmp5_);
#line 307 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp2_ = _tmp7_;
#line 307 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 307 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (file);
#line 307 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (info);
#line 1756 "TeeJee.FileSystem.c"
				goto __catch71_g_error;
			}
#line 307 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp8_ = _tmp2_;
#line 307 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp2_ = NULL;
#line 307 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (info);
#line 307 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			info = _tmp8_;
#line 308 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp9_ = info;
#line 308 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			g_file_info_get_modification_time (_tmp9_, &_tmp10_);
#line 308 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp11_ = g_date_time_new_from_timeval_utc (&_tmp10_);
#line 308 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp12_ = _tmp11_;
#line 308 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp13_ = g_date_time_to_local (_tmp12_);
#line 308 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp14_ = _tmp13_;
#line 308 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_g_date_time_unref0 (_tmp12_);
#line 308 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			result = _tmp14_;
#line 308 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (_tmp2_);
#line 308 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (file);
#line 308 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (info);
#line 308 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			return result;
#line 1791 "TeeJee.FileSystem.c"
		}
#line 303 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_object_unref0 (file);
#line 303 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_object_unref0 (info);
#line 1797 "TeeJee.FileSystem.c"
	}
	goto __finally71;
	__catch71_g_error:
	{
		GError* e = NULL;
		GError* _tmp15_;
		const gchar* _tmp16_;
#line 303 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		e = _inner_error_;
#line 303 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_inner_error_ = NULL;
#line 312 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp15_ = e;
#line 312 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp16_ = _tmp15_->message;
#line 312 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp16_, FALSE, FALSE);
#line 303 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_error_free0 (e);
#line 1817 "TeeJee.FileSystem.c"
	}
	__finally71:
#line 303 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 303 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 303 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		g_clear_error (&_inner_error_);
#line 303 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		return NULL;
#line 1828 "TeeJee.FileSystem.c"
	}
#line 315 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp17_ = g_date_time_new_from_unix_utc ((gint64) 0);
#line 315 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	result = _tmp17_;
#line 315 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	return result;
#line 1836 "TeeJee.FileSystem.c"
}


gchar*
tee_jee_file_system_file_get_symlink_target (const gchar* file_path)
{
	gchar* result = NULL;
	gchar* _tmp14_;
	GError * _inner_error_ = NULL;
#line 318 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (file_path != NULL, NULL);
#line 1848 "TeeJee.FileSystem.c"
	{
		GFileInfo* info = NULL;
		GFile* file = NULL;
		GFile* _tmp0_;
		GFile* _tmp1_;
#line 321 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp0_ = g_file_parse_name (file_path);
#line 321 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		file = _tmp0_;
#line 322 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp1_ = file;
#line 322 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		if (g_file_query_exists (_tmp1_, NULL)) {
#line 1862 "TeeJee.FileSystem.c"
			GFileInfo* _tmp2_ = NULL;
			GFile* _tmp3_;
			gchar* _tmp4_;
			gchar* _tmp5_;
			GFileInfo* _tmp6_;
			GFileInfo* _tmp7_;
			GFileInfo* _tmp8_;
			GFileInfo* _tmp9_;
			const gchar* _tmp10_;
			gchar* _tmp11_;
#line 323 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp3_ = file;
#line 323 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp4_ = g_strdup_printf ("%s", G_FILE_ATTRIBUTE_STANDARD_SYMLINK_TARGET);
#line 323 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp5_ = _tmp4_;
#line 323 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp6_ = g_file_query_info (_tmp3_, _tmp5_, 0, NULL, &_inner_error_);
#line 323 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp7_ = _tmp6_;
#line 323 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (_tmp5_);
#line 323 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp2_ = _tmp7_;
#line 323 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 323 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (file);
#line 323 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (info);
#line 1893 "TeeJee.FileSystem.c"
				goto __catch72_g_error;
			}
#line 323 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp8_ = _tmp2_;
#line 323 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp2_ = NULL;
#line 323 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (info);
#line 323 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			info = _tmp8_;
#line 324 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp9_ = info;
#line 324 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp10_ = g_file_info_get_symlink_target (_tmp9_);
#line 324 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp11_ = g_strdup (_tmp10_);
#line 324 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			result = _tmp11_;
#line 324 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (_tmp2_);
#line 324 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (file);
#line 324 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (info);
#line 324 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			return result;
#line 1920 "TeeJee.FileSystem.c"
		}
#line 319 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_object_unref0 (file);
#line 319 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_object_unref0 (info);
#line 1926 "TeeJee.FileSystem.c"
	}
	goto __finally72;
	__catch72_g_error:
	{
		GError* e = NULL;
		GError* _tmp12_;
		const gchar* _tmp13_;
#line 319 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		e = _inner_error_;
#line 319 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_inner_error_ = NULL;
#line 328 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp12_ = e;
#line 328 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp13_ = _tmp12_->message;
#line 328 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp13_, FALSE, FALSE);
#line 319 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_error_free0 (e);
#line 1946 "TeeJee.FileSystem.c"
	}
	__finally72:
#line 319 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 319 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 319 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		g_clear_error (&_inner_error_);
#line 319 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		return NULL;
#line 1957 "TeeJee.FileSystem.c"
	}
#line 331 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp14_ = g_strdup ("");
#line 331 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	result = _tmp14_;
#line 331 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	return result;
#line 1965 "TeeJee.FileSystem.c"
}


gboolean
tee_jee_file_system_dir_exists (const gchar* dir_path)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 336 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (dir_path != NULL, FALSE);
#line 338 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	if (g_file_test (dir_path, G_FILE_TEST_EXISTS)) {
#line 338 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp0_ = g_file_test (dir_path, G_FILE_TEST_IS_DIR);
#line 1980 "TeeJee.FileSystem.c"
	} else {
#line 338 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp0_ = FALSE;
#line 1984 "TeeJee.FileSystem.c"
	}
#line 338 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	result = _tmp0_;
#line 338 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	return result;
#line 1990 "TeeJee.FileSystem.c"
}


gboolean
tee_jee_file_system_dir_create (const gchar* dir_path,
                                gboolean show_message)
{
	gboolean result = FALSE;
	gboolean _tmp18_ = FALSE;
	GError * _inner_error_ = NULL;
#line 341 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (dir_path != NULL, FALSE);
#line 2003 "TeeJee.FileSystem.c"
	{
		GFile* dir = NULL;
		GFile* _tmp0_;
		GFile* _tmp1_;
#line 346 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp0_ = g_file_parse_name (dir_path);
#line 346 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		dir = _tmp0_;
#line 348 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp1_ = dir;
#line 348 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		if (g_file_query_exists (_tmp1_, NULL) == FALSE) {
#line 2016 "TeeJee.FileSystem.c"
			gboolean ok = FALSE;
			GFile* _tmp2_;
#line 350 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp2_ = dir;
#line 350 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			ok = g_file_make_directory_with_parents (_tmp2_, NULL, &_inner_error_);
#line 350 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 350 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (dir);
#line 2027 "TeeJee.FileSystem.c"
				goto __catch73_g_error;
			}
#line 352 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			if (show_message) {
#line 2032 "TeeJee.FileSystem.c"
				gboolean _tmp3_;
#line 353 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
				_tmp3_ = ok;
#line 353 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
				if (_tmp3_) {
#line 2038 "TeeJee.FileSystem.c"
					gchar* _tmp4_;
					gchar* _tmp5_;
					gchar* _tmp6_;
					gchar* _tmp7_;
#line 354 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
					_tmp4_ = g_strdup_printf (": %s", dir_path);
#line 354 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
					_tmp5_ = _tmp4_;
#line 354 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
					_tmp6_ = g_strconcat (_ ("Created directory"), _tmp5_, NULL);
#line 354 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
					_tmp7_ = _tmp6_;
#line 354 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
					tee_jee_logging_log_msg (_tmp7_, FALSE);
#line 354 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
					_g_free0 (_tmp7_);
#line 354 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
					_g_free0 (_tmp5_);
#line 2057 "TeeJee.FileSystem.c"
				} else {
					gchar* _tmp8_;
					gchar* _tmp9_;
					gchar* _tmp10_;
					gchar* _tmp11_;
#line 357 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
					_tmp8_ = g_strdup_printf (": %s", dir_path);
#line 357 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
					_tmp9_ = _tmp8_;
#line 357 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
					_tmp10_ = g_strconcat (_ ("Failed to create directory"), _tmp9_, NULL);
#line 357 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
					_tmp11_ = _tmp10_;
#line 357 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
					tee_jee_logging_log_error (_tmp11_, FALSE, FALSE);
#line 357 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
					_g_free0 (_tmp11_);
#line 357 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
					_g_free0 (_tmp9_);
#line 2077 "TeeJee.FileSystem.c"
				}
			}
		}
#line 362 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		result = TRUE;
#line 362 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_object_unref0 (dir);
#line 362 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		return result;
#line 2087 "TeeJee.FileSystem.c"
	}
	goto __finally73;
	__catch73_g_error:
	{
		GError* e = NULL;
		GError* _tmp12_;
		const gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
#line 345 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		e = _inner_error_;
#line 345 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_inner_error_ = NULL;
#line 365 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp12_ = e;
#line 365 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp13_ = _tmp12_->message;
#line 365 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp13_, FALSE, FALSE);
#line 366 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp14_ = g_strdup_printf (": %s", dir_path);
#line 366 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp15_ = _tmp14_;
#line 366 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp16_ = g_strconcat (_ ("Failed to create directory"), _tmp15_, NULL);
#line 366 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp17_ = _tmp16_;
#line 366 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp17_, FALSE, FALSE);
#line 366 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp17_);
#line 366 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp15_);
#line 367 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		result = FALSE;
#line 367 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_error_free0 (e);
#line 367 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		return result;
#line 2129 "TeeJee.FileSystem.c"
	}
	__finally73:
#line 345 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 345 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	g_clear_error (&_inner_error_);
#line 345 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	return _tmp18_;
#line 2138 "TeeJee.FileSystem.c"
}


gboolean
tee_jee_file_system_dir_delete (const gchar* dir_path,
                                gboolean show_message)
{
	gboolean result = FALSE;
	gchar* cmd = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gint status = 0;
	const gchar* _tmp5_;
	gchar* _tmp6_ = NULL;
	gchar* _tmp7_ = NULL;
	gint _tmp8_;
	gint _tmp20_;
#line 371 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (dir_path != NULL, FALSE);
#line 375 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	if (!tee_jee_file_system_dir_exists (dir_path)) {
#line 376 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		result = TRUE;
#line 376 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		return result;
#line 2169 "TeeJee.FileSystem.c"
	}
#line 379 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp0_ = tee_jee_file_system_escape_single_quote (dir_path);
#line 379 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp1_ = _tmp0_;
#line 379 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp2_ = g_strdup_printf ("rm -rf '%s'", _tmp1_);
#line 379 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp3_ = _tmp2_;
#line 379 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (_tmp1_);
#line 379 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	cmd = _tmp3_;
#line 381 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp4_ = cmd;
#line 381 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	tee_jee_logging_log_debug (_tmp4_);
#line 384 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp5_ = cmd;
#line 384 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp8_ = tee_jee_process_helper_exec_sync (_tmp5_, &_tmp6_, &_tmp7_);
#line 384 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_out);
#line 384 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	std_out = _tmp6_;
#line 384 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_err);
#line 384 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	std_err = _tmp7_;
#line 384 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	status = _tmp8_;
#line 386 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	if (show_message) {
#line 2203 "TeeJee.FileSystem.c"
		gint _tmp9_;
#line 387 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp9_ = status;
#line 387 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		if (_tmp9_ == 0) {
#line 2209 "TeeJee.FileSystem.c"
			gchar* _tmp10_;
			gchar* _tmp11_;
			gchar* _tmp12_;
			gchar* _tmp13_;
#line 388 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp10_ = g_strdup_printf (": %s", dir_path);
#line 388 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp11_ = _tmp10_;
#line 388 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp12_ = g_strconcat (_ ("Deleted directory"), _tmp11_, NULL);
#line 388 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp13_ = _tmp12_;
#line 388 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			tee_jee_logging_log_msg (_tmp13_, FALSE);
#line 388 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (_tmp13_);
#line 388 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (_tmp11_);
#line 2228 "TeeJee.FileSystem.c"
		} else {
			gchar* _tmp14_;
			gchar* _tmp15_;
			gchar* _tmp16_;
			gchar* _tmp17_;
			const gchar* _tmp18_;
			const gchar* _tmp19_;
#line 391 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp14_ = g_strdup_printf (": %s", dir_path);
#line 391 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp15_ = _tmp14_;
#line 391 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp16_ = g_strconcat (_ ("Failed to delete directory"), _tmp15_, NULL);
#line 391 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp17_ = _tmp16_;
#line 391 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			tee_jee_logging_log_error (_tmp17_, FALSE, FALSE);
#line 391 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (_tmp17_);
#line 391 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (_tmp15_);
#line 392 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp18_ = std_out;
#line 392 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			tee_jee_logging_log_error (_tmp18_, FALSE, FALSE);
#line 393 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp19_ = std_err;
#line 393 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			tee_jee_logging_log_error (_tmp19_, FALSE, FALSE);
#line 2258 "TeeJee.FileSystem.c"
		}
	}
#line 397 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp20_ = status;
#line 397 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	result = _tmp20_ == 0;
#line 397 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_err);
#line 397 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_out);
#line 397 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (cmd);
#line 397 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	return result;
#line 2273 "TeeJee.FileSystem.c"
}


gboolean
tee_jee_file_system_dir_move_to_trash (const gchar* dir_path)
{
	gboolean result = FALSE;
#line 400 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (dir_path != NULL, FALSE);
#line 401 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	result = tee_jee_file_system_file_move_to_trash (dir_path);
#line 401 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	return result;
#line 2287 "TeeJee.FileSystem.c"
}


gboolean
tee_jee_file_system_dir_is_empty (const gchar* dir_path)
{
	gboolean result = FALSE;
	gboolean _tmp14_ = FALSE;
	GError * _inner_error_ = NULL;
#line 404 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (dir_path != NULL, FALSE);
#line 2299 "TeeJee.FileSystem.c"
	{
		gboolean is_empty = FALSE;
		GFile* dir = NULL;
		GFile* _tmp0_;
		GFile* _tmp1_;
#line 409 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		is_empty = TRUE;
#line 410 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp0_ = g_file_parse_name (dir_path);
#line 410 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		dir = _tmp0_;
#line 411 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp1_ = dir;
#line 411 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		if (g_file_query_exists (_tmp1_, NULL)) {
#line 2315 "TeeJee.FileSystem.c"
			GFileInfo* info = NULL;
			GFileEnumerator* enu = NULL;
			GFile* _tmp2_;
			gchar* _tmp3_;
			gchar* _tmp4_;
			GFileEnumerator* _tmp5_;
			GFileEnumerator* _tmp6_;
#line 413 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp2_ = dir;
#line 413 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp3_ = g_strdup_printf ("%s", G_FILE_ATTRIBUTE_STANDARD_NAME);
#line 413 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp4_ = _tmp3_;
#line 413 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp5_ = g_file_enumerate_children (_tmp2_, _tmp4_, 0, NULL, &_inner_error_);
#line 413 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp6_ = _tmp5_;
#line 413 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (_tmp4_);
#line 413 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			enu = _tmp6_;
#line 413 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 413 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (info);
#line 413 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (dir);
#line 2343 "TeeJee.FileSystem.c"
				goto __catch74_g_error;
			}
#line 414 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			while (TRUE) {
#line 2348 "TeeJee.FileSystem.c"
				GFileInfo* _tmp7_ = NULL;
				GFileEnumerator* _tmp8_;
				GFileInfo* _tmp9_;
				GFileInfo* _tmp10_;
				GFileInfo* _tmp11_;
#line 414 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
				_tmp8_ = enu;
#line 414 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
				_tmp9_ = g_file_enumerator_next_file (_tmp8_, NULL, &_inner_error_);
#line 414 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
				_tmp7_ = _tmp9_;
#line 414 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 414 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
					_g_object_unref0 (enu);
#line 414 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
					_g_object_unref0 (info);
#line 414 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
					_g_object_unref0 (dir);
#line 2368 "TeeJee.FileSystem.c"
					goto __catch74_g_error;
				}
#line 414 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
				_tmp10_ = _tmp7_;
#line 414 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
				_tmp7_ = NULL;
#line 414 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (info);
#line 414 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
				info = _tmp10_;
#line 414 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
				_tmp11_ = info;
#line 414 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
				if (!(_tmp11_ != NULL)) {
#line 414 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
					_g_object_unref0 (_tmp7_);
#line 414 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
					break;
#line 2387 "TeeJee.FileSystem.c"
				}
#line 415 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
				is_empty = FALSE;
#line 416 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (_tmp7_);
#line 416 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
				break;
#line 2395 "TeeJee.FileSystem.c"
			}
#line 411 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (enu);
#line 411 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (info);
#line 2401 "TeeJee.FileSystem.c"
		}
#line 419 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		result = is_empty;
#line 419 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_object_unref0 (dir);
#line 419 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		return result;
#line 2409 "TeeJee.FileSystem.c"
	}
	goto __finally74;
	__catch74_g_error:
	{
		GError* e = NULL;
		GError* _tmp12_;
		const gchar* _tmp13_;
#line 408 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		e = _inner_error_;
#line 408 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_inner_error_ = NULL;
#line 422 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp12_ = e;
#line 422 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp13_ = _tmp12_->message;
#line 422 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp13_, FALSE, FALSE);
#line 423 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		result = FALSE;
#line 423 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_error_free0 (e);
#line 423 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		return result;
#line 2433 "TeeJee.FileSystem.c"
	}
	__finally74:
#line 408 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 408 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	g_clear_error (&_inner_error_);
#line 408 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	return _tmp14_;
#line 2442 "TeeJee.FileSystem.c"
}


static gboolean
int64_try_parse (const gchar* str,
                 gint64* _result_,
                 const gchar* * unparsed)
{
	gint64 _vala_result = 0LL;
	const gchar* _vala_unparsed = NULL;
	gboolean result = FALSE;
	gchar* endptr = NULL;
	gchar* _tmp0_ = NULL;
	gint64 _tmp1_;
	gchar* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
#line 692 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, FALSE);
#line 694 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp1_ = g_ascii_strtoll (str, &_tmp0_, (guint) 0);
#line 694 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	endptr = _tmp0_;
#line 694 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_vala_result = _tmp1_;
#line 695 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp2_ = endptr;
#line 695 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp3_ = strlen (str);
#line 695 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp4_ = _tmp3_;
#line 695 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (_tmp2_ == (((gchar*) str) + _tmp4_)) {
#line 696 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_vala_unparsed = "";
#line 697 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		result = TRUE;
#line 697 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		if (_result_) {
#line 697 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			*_result_ = _vala_result;
#line 2484 "TeeJee.FileSystem.c"
		}
#line 697 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		if (unparsed) {
#line 697 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			*unparsed = _vala_unparsed;
#line 2490 "TeeJee.FileSystem.c"
		}
#line 697 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		return result;
#line 2494 "TeeJee.FileSystem.c"
	} else {
		gchar* _tmp5_;
#line 699 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp5_ = endptr;
#line 699 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_vala_unparsed = (const gchar*) _tmp5_;
#line 700 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		result = FALSE;
#line 700 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		if (_result_) {
#line 700 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			*_result_ = _vala_result;
#line 2507 "TeeJee.FileSystem.c"
		}
#line 700 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		if (unparsed) {
#line 700 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			*unparsed = _vala_unparsed;
#line 2513 "TeeJee.FileSystem.c"
		}
#line 700 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		return result;
#line 2517 "TeeJee.FileSystem.c"
	}
#line 692 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (_result_) {
#line 692 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		*_result_ = _vala_result;
#line 2523 "TeeJee.FileSystem.c"
	}
#line 692 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (unparsed) {
#line 692 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		*unparsed = _vala_unparsed;
#line 2529 "TeeJee.FileSystem.c"
	}
}


gboolean
tee_jee_file_system_filesystem_supports_hardlinks (const gchar* path,
                                                   gboolean* is_readonly)
{
	gboolean _vala_is_readonly = FALSE;
	gboolean result = FALSE;
	gboolean supports_hardlinks = FALSE;
	gchar* test_file = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_;
#line 427 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 428 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	supports_hardlinks = FALSE;
#line 429 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_vala_is_readonly = FALSE;
#line 431 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp0_ = tee_jee_misc_random_string (8, "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz1234567890");
#line 431 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp1_ = _tmp0_;
#line 431 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp2_ = g_strconcat (_tmp1_, "~", NULL);
#line 431 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp3_ = _tmp2_;
#line 431 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp4_ = tee_jee_file_system_path_combine (path, _tmp3_);
#line 431 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp5_ = _tmp4_;
#line 431 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (_tmp3_);
#line 431 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (_tmp1_);
#line 431 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	test_file = _tmp5_;
#line 433 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp6_ = test_file;
#line 433 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	if (tee_jee_file_system_file_write (_tmp6_, "")) {
#line 2577 "TeeJee.FileSystem.c"
		gchar* test_file2 = NULL;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* cmd = NULL;
		const gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		const gchar* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		const gchar* _tmp21_;
		gint status = 0;
		const gchar* _tmp22_;
		gint _tmp23_;
		const gchar* _tmp24_;
		gchar* _tmp25_;
		gchar* _tmp26_;
		gchar* _tmp27_;
		const gchar* _tmp28_;
		gchar* std_out = NULL;
		gchar* std_err = NULL;
		const gchar* _tmp29_;
		gchar* _tmp30_ = NULL;
		gchar* _tmp31_ = NULL;
		gint _tmp32_;
		const gchar* _tmp33_;
		gchar* _tmp34_;
		gchar* _tmp35_;
		gint64 count = 0LL;
		const gchar* _tmp36_;
		gint64 _tmp37_ = 0LL;
		gboolean _tmp38_;
		const gchar* _tmp40_;
		const gchar* _tmp41_;
#line 435 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp7_ = tee_jee_misc_random_string (8, "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz1234567890");
#line 435 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp8_ = _tmp7_;
#line 435 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp9_ = g_strconcat (_tmp8_, "~", NULL);
#line 435 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp10_ = _tmp9_;
#line 435 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp11_ = tee_jee_file_system_path_combine (path, _tmp10_);
#line 435 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp12_ = _tmp11_;
#line 435 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp10_);
#line 435 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp8_);
#line 435 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		test_file2 = _tmp12_;
#line 437 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp13_ = test_file;
#line 437 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp14_ = tee_jee_file_system_escape_single_quote (_tmp13_);
#line 437 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp15_ = _tmp14_;
#line 437 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp16_ = test_file2;
#line 437 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp17_ = tee_jee_file_system_escape_single_quote (_tmp16_);
#line 437 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp18_ = _tmp17_;
#line 437 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp19_ = g_strdup_printf ("ln '%s' '%s'", _tmp15_, _tmp18_);
#line 437 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp20_ = _tmp19_;
#line 437 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp18_);
#line 437 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp15_);
#line 437 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		cmd = _tmp20_;
#line 441 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp21_ = cmd;
#line 441 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_debug (_tmp21_);
#line 443 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp22_ = cmd;
#line 443 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp23_ = tee_jee_process_helper_exec_sync (_tmp22_, NULL, NULL);
#line 443 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		status = _tmp23_;
#line 445 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp24_ = test_file;
#line 445 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp25_ = tee_jee_file_system_escape_single_quote (_tmp24_);
#line 445 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp26_ = _tmp25_;
#line 445 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp27_ = g_strdup_printf ("stat --printf '%%h' '%s'", _tmp26_);
#line 445 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (cmd);
#line 445 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		cmd = _tmp27_;
#line 445 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp26_);
#line 448 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp28_ = cmd;
#line 448 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_debug (_tmp28_);
#line 451 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp29_ = cmd;
#line 451 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp32_ = tee_jee_process_helper_exec_sync (_tmp29_, &_tmp30_, &_tmp31_);
#line 451 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (std_out);
#line 451 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		std_out = _tmp30_;
#line 451 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (std_err);
#line 451 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		std_err = _tmp31_;
#line 451 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		status = _tmp32_;
#line 452 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp33_ = std_out;
#line 452 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp34_ = g_strdup_printf ("stdout: %s", _tmp33_);
#line 452 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp35_ = _tmp34_;
#line 452 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_debug (_tmp35_);
#line 452 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp35_);
#line 454 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		count = (gint64) 0;
#line 455 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp36_ = std_out;
#line 455 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp38_ = int64_try_parse (_tmp36_, &_tmp37_, NULL);
#line 455 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		count = _tmp37_;
#line 455 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		if (_tmp38_) {
#line 2720 "TeeJee.FileSystem.c"
			gint64 _tmp39_;
#line 456 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp39_ = count;
#line 456 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			if (_tmp39_ > ((gint64) 1)) {
#line 457 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
				supports_hardlinks = TRUE;
#line 2728 "TeeJee.FileSystem.c"
			}
		}
#line 461 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp40_ = test_file2;
#line 461 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		tee_jee_file_system_file_delete (_tmp40_);
#line 462 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp41_ = test_file;
#line 462 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		tee_jee_file_system_file_delete (_tmp41_);
#line 433 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (std_err);
#line 433 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (std_out);
#line 433 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (cmd);
#line 433 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (test_file2);
#line 2747 "TeeJee.FileSystem.c"
	} else {
#line 465 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_vala_is_readonly = TRUE;
#line 2751 "TeeJee.FileSystem.c"
	}
#line 468 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	result = supports_hardlinks;
#line 468 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (test_file);
#line 468 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	if (is_readonly) {
#line 468 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		*is_readonly = _vala_is_readonly;
#line 2761 "TeeJee.FileSystem.c"
	}
#line 468 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	return result;
#line 2765 "TeeJee.FileSystem.c"
}


static gint
__lambda18_ (const gchar* a,
             const gchar* b)
{
	gint result = 0;
	GCompareFunc _tmp0_;
#line 489 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 489 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 490 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp0_ = g_strcmp0;
#line 490 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	result = _tmp0_ (a, b);
#line 490 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	return result;
#line 2785 "TeeJee.FileSystem.c"
}


static gint
___lambda18__gcompare_data_func (gconstpointer a,
                                 gconstpointer b,
                                 gpointer self)
{
	gint result;
	result = __lambda18_ ((const gchar*) a, (const gchar*) b);
#line 489 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	return result;
#line 2798 "TeeJee.FileSystem.c"
}


GeeArrayList*
tee_jee_file_system_dir_list_names (const gchar* path)
{
	GeeArrayList* result = NULL;
	GeeArrayList* list = NULL;
	GeeArrayList* _tmp0_;
	GCompareDataFunc entry_compare = NULL;
	void* entry_compare_target;
	GDestroyNotify entry_compare_target_destroy_notify;
	GeeArrayList* _tmp19_;
	GCompareDataFunc _tmp20_;
	void* _tmp20__target;
	GDestroyNotify _tmp20__target_destroy_notify;
	GError * _inner_error_ = NULL;
#line 471 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 472 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp0_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 472 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	list = _tmp0_;
#line 2822 "TeeJee.FileSystem.c"
	{
		GFile* f_home = NULL;
		GFile* _tmp1_;
		GFileEnumerator* enumerator = NULL;
		GFile* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GFileEnumerator* _tmp5_;
		GFileEnumerator* _tmp6_;
		GFileInfo* file = NULL;
#line 476 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp1_ = g_file_new_for_path (path);
#line 476 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		f_home = _tmp1_;
#line 477 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp2_ = f_home;
#line 477 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp3_ = g_strdup_printf ("%s", G_FILE_ATTRIBUTE_STANDARD_NAME);
#line 477 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp4_ = _tmp3_;
#line 477 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp5_ = g_file_enumerate_children (_tmp2_, _tmp4_, 0, NULL, &_inner_error_);
#line 477 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp6_ = _tmp5_;
#line 477 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp4_);
#line 477 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		enumerator = _tmp6_;
#line 477 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 477 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (f_home);
#line 2855 "TeeJee.FileSystem.c"
			goto __catch75_g_error;
		}
#line 479 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		while (TRUE) {
#line 2860 "TeeJee.FileSystem.c"
			GFileInfo* _tmp7_ = NULL;
			GFileEnumerator* _tmp8_;
			GFileInfo* _tmp9_;
			GFileInfo* _tmp10_;
			GFileInfo* _tmp11_;
			gchar* name = NULL;
			GFileInfo* _tmp12_;
			const gchar* _tmp13_;
			gchar* _tmp14_;
			GeeArrayList* _tmp15_;
			const gchar* _tmp16_;
#line 479 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp8_ = enumerator;
#line 479 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp9_ = g_file_enumerator_next_file (_tmp8_, NULL, &_inner_error_);
#line 479 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp7_ = _tmp9_;
#line 479 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 479 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (file);
#line 479 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (enumerator);
#line 479 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (f_home);
#line 2886 "TeeJee.FileSystem.c"
				goto __catch75_g_error;
			}
#line 479 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp10_ = _tmp7_;
#line 479 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp7_ = NULL;
#line 479 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (file);
#line 479 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			file = _tmp10_;
#line 479 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp11_ = file;
#line 479 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			if (!(_tmp11_ != NULL)) {
#line 479 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (_tmp7_);
#line 479 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
				break;
#line 2905 "TeeJee.FileSystem.c"
			}
#line 480 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp12_ = file;
#line 480 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp13_ = g_file_info_get_name (_tmp12_);
#line 480 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp14_ = g_strdup (_tmp13_);
#line 480 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			name = _tmp14_;
#line 481 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp15_ = list;
#line 481 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp16_ = name;
#line 481 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp15_, _tmp16_);
#line 479 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (name);
#line 479 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (_tmp7_);
#line 2925 "TeeJee.FileSystem.c"
		}
#line 474 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_object_unref0 (file);
#line 474 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_object_unref0 (enumerator);
#line 474 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_object_unref0 (f_home);
#line 2933 "TeeJee.FileSystem.c"
	}
	goto __finally75;
	__catch75_g_error:
	{
		GError* e = NULL;
		GError* _tmp17_;
		const gchar* _tmp18_;
#line 474 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		e = _inner_error_;
#line 474 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_inner_error_ = NULL;
#line 485 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp17_ = e;
#line 485 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp18_ = _tmp17_->message;
#line 485 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp18_, FALSE, FALSE);
#line 474 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_error_free0 (e);
#line 2953 "TeeJee.FileSystem.c"
	}
	__finally75:
#line 474 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 474 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_object_unref0 (list);
#line 474 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 474 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		g_clear_error (&_inner_error_);
#line 474 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		return NULL;
#line 2966 "TeeJee.FileSystem.c"
	}
#line 489 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	entry_compare = ___lambda18__gcompare_data_func;
#line 489 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	entry_compare_target = NULL;
#line 489 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	entry_compare_target_destroy_notify = NULL;
#line 492 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp19_ = list;
#line 492 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp20_ = entry_compare;
#line 492 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp20__target = entry_compare_target;
#line 492 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp20__target_destroy_notify = entry_compare_target_destroy_notify;
#line 492 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	entry_compare = NULL;
#line 492 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	entry_compare_target = NULL;
#line 492 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	entry_compare_target_destroy_notify = NULL;
#line 492 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	gee_list_sort ((GeeList*) _tmp19_, _tmp20_, _tmp20__target, _tmp20__target_destroy_notify);
#line 494 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	result = list;
#line 494 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	(entry_compare_target_destroy_notify == NULL) ? NULL : (entry_compare_target_destroy_notify (entry_compare_target), NULL);
#line 494 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	entry_compare = NULL;
#line 494 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	entry_compare_target = NULL;
#line 494 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	entry_compare_target_destroy_notify = NULL;
#line 494 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	return result;
#line 3002 "TeeJee.FileSystem.c"
}


gboolean
tee_jee_file_system_dir_tar (const gchar* src_dir,
                             const gchar* tar_file,
                             gboolean recursion)
{
	gboolean result = FALSE;
#line 497 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (src_dir != NULL, FALSE);
#line 497 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (tar_file != NULL, FALSE);
#line 498 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	if (tee_jee_file_system_dir_exists (src_dir)) {
#line 3018 "TeeJee.FileSystem.c"
		gchar* src_parent = NULL;
		gchar* _tmp0_;
		gchar* src_name = NULL;
		gchar* _tmp1_;
		const gchar* _tmp2_ = NULL;
		gchar* cmd = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		const gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		const gchar* _tmp13_;
		gchar* stdout = NULL;
		gchar* stderr = NULL;
		gint status = 0;
		const gchar* _tmp14_;
		gchar* _tmp15_ = NULL;
		gchar* _tmp16_ = NULL;
		gint _tmp17_;
		gint _tmp18_;
#line 500 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		if (tee_jee_file_system_file_exists (tar_file)) {
#line 501 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			tee_jee_file_system_file_delete (tar_file);
#line 3048 "TeeJee.FileSystem.c"
		}
#line 504 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp0_ = tee_jee_file_system_file_parent (src_dir);
#line 504 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		src_parent = _tmp0_;
#line 505 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp1_ = tee_jee_file_system_file_basename (src_dir);
#line 505 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		src_name = _tmp1_;
#line 509 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		if (recursion) {
#line 509 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp2_ = "";
#line 3062 "TeeJee.FileSystem.c"
		} else {
#line 509 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp2_ = "no-";
#line 3066 "TeeJee.FileSystem.c"
		}
#line 507 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp3_ = tee_jee_file_system_escape_single_quote (tar_file);
#line 507 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp4_ = _tmp3_;
#line 507 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp5_ = src_parent;
#line 507 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp6_ = tee_jee_file_system_escape_single_quote (_tmp5_);
#line 507 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp7_ = _tmp6_;
#line 507 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp8_ = src_name;
#line 507 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp9_ = tee_jee_file_system_escape_single_quote (_tmp8_);
#line 507 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp10_ = _tmp9_;
#line 507 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp11_ = g_strdup_printf ("tar cvf '%s' --overwrite --%srecursion -C '%s' '%s'\n", _tmp4_, _tmp2_, _tmp7_, _tmp10_);
#line 507 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp12_ = _tmp11_;
#line 507 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp10_);
#line 507 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp7_);
#line 507 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp4_);
#line 507 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		cmd = _tmp12_;
#line 513 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp13_ = cmd;
#line 513 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_debug (_tmp13_);
#line 516 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp14_ = cmd;
#line 516 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp17_ = tee_jee_process_helper_exec_script_sync (_tmp14_, &_tmp15_, &_tmp16_, FALSE, FALSE, TRUE, FALSE);
#line 516 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (stdout);
#line 516 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		stdout = _tmp15_;
#line 516 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (stderr);
#line 516 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		stderr = _tmp16_;
#line 516 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		status = _tmp17_;
#line 517 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp18_ = status;
#line 517 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		if (_tmp18_ == 0) {
#line 518 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			result = TRUE;
#line 518 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (stderr);
#line 518 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (stdout);
#line 518 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (cmd);
#line 518 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (src_name);
#line 518 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (src_parent);
#line 518 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			return result;
#line 3132 "TeeJee.FileSystem.c"
		} else {
			const gchar* _tmp19_;
#line 521 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp19_ = stderr;
#line 521 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			tee_jee_logging_log_msg (_tmp19_, FALSE);
#line 3139 "TeeJee.FileSystem.c"
		}
#line 498 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (stderr);
#line 498 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (stdout);
#line 498 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (cmd);
#line 498 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (src_name);
#line 498 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (src_parent);
#line 3151 "TeeJee.FileSystem.c"
	} else {
		gchar* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
		gchar* _tmp23_;
#line 525 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp20_ = g_strdup_printf (": %s", src_dir);
#line 525 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp21_ = _tmp20_;
#line 525 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp22_ = g_strconcat (_ ("Dir not found"), _tmp21_, NULL);
#line 525 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp23_ = _tmp22_;
#line 525 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp23_, FALSE, FALSE);
#line 525 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp23_);
#line 525 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp21_);
#line 3171 "TeeJee.FileSystem.c"
	}
#line 528 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	result = FALSE;
#line 528 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	return result;
#line 3177 "TeeJee.FileSystem.c"
}


gboolean
tee_jee_file_system_dir_untar (const gchar* tar_file,
                               const gchar* dst_dir)
{
	gboolean result = FALSE;
#line 531 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (tar_file != NULL, FALSE);
#line 531 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (dst_dir != NULL, FALSE);
#line 532 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	if (tee_jee_file_system_file_exists (tar_file)) {
#line 3192 "TeeJee.FileSystem.c"
		gchar* cmd = NULL;
		gchar* _tmp0_;
		gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		const gchar* _tmp6_;
		gchar* stdout = NULL;
		gchar* stderr = NULL;
		gint status = 0;
		const gchar* _tmp7_;
		gchar* _tmp8_ = NULL;
		gchar* _tmp9_ = NULL;
		gint _tmp10_;
		gint _tmp11_;
#line 534 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		if (!tee_jee_file_system_dir_exists (dst_dir)) {
#line 535 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			tee_jee_file_system_dir_create (dst_dir, FALSE);
#line 3213 "TeeJee.FileSystem.c"
		}
#line 538 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp0_ = tee_jee_file_system_escape_single_quote (tar_file);
#line 538 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp1_ = _tmp0_;
#line 538 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp2_ = tee_jee_file_system_escape_single_quote (dst_dir);
#line 538 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp3_ = _tmp2_;
#line 538 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp4_ = g_strdup_printf ("tar xvf '%s' --overwrite --same-permissions -C '%s'\n", _tmp1_, _tmp3_);
#line 538 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp5_ = _tmp4_;
#line 538 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp3_);
#line 538 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp1_);
#line 538 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		cmd = _tmp5_;
#line 542 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp6_ = cmd;
#line 542 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_debug (_tmp6_);
#line 545 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp7_ = cmd;
#line 545 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp10_ = tee_jee_process_helper_exec_script_sync (_tmp7_, &_tmp8_, &_tmp9_, FALSE, FALSE, TRUE, FALSE);
#line 545 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (stdout);
#line 545 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		stdout = _tmp8_;
#line 545 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (stderr);
#line 545 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		stderr = _tmp9_;
#line 545 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		status = _tmp10_;
#line 546 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp11_ = status;
#line 546 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		if (_tmp11_ == 0) {
#line 547 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			result = TRUE;
#line 547 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (stderr);
#line 547 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (stdout);
#line 547 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (cmd);
#line 547 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			return result;
#line 3265 "TeeJee.FileSystem.c"
		} else {
			const gchar* _tmp12_;
#line 550 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp12_ = stderr;
#line 550 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			tee_jee_logging_log_msg (_tmp12_, FALSE);
#line 3272 "TeeJee.FileSystem.c"
		}
#line 532 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (stderr);
#line 532 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (stdout);
#line 532 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (cmd);
#line 3280 "TeeJee.FileSystem.c"
	} else {
		gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
#line 554 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp13_ = g_strdup_printf (": %s", tar_file);
#line 554 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp14_ = _tmp13_;
#line 554 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp15_ = g_strconcat (_ ("File not found"), _tmp14_, NULL);
#line 554 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp16_ = _tmp15_;
#line 554 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp16_, FALSE, FALSE);
#line 554 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp16_);
#line 554 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp14_);
#line 3300 "TeeJee.FileSystem.c"
	}
#line 557 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	result = FALSE;
#line 557 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	return result;
#line 3306 "TeeJee.FileSystem.c"
}


gboolean
tee_jee_file_system_chown (const gchar* dir_path,
                           const gchar* user,
                           const gchar* group)
{
	gboolean result = FALSE;
	gchar* cmd = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gint status = 0;
	gint _tmp4_;
#line 560 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (dir_path != NULL, FALSE);
#line 560 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (user != NULL, FALSE);
#line 560 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (group != NULL, FALSE);
#line 561 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp0_ = tee_jee_file_system_escape_single_quote (dir_path);
#line 561 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp1_ = _tmp0_;
#line 561 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp2_ = g_strdup_printf ("chown %s:%s -R '%s'", user, group, _tmp1_);
#line 561 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp3_ = _tmp2_;
#line 561 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (_tmp1_);
#line 561 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	cmd = _tmp3_;
#line 562 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp4_ = tee_jee_process_helper_exec_sync (cmd, NULL, NULL);
#line 562 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	status = _tmp4_;
#line 563 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	result = status == 0;
#line 563 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (cmd);
#line 563 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	return result;
#line 3351 "TeeJee.FileSystem.c"
}


glong
tee_jee_file_system_dir_count (const gchar* path)
{
	glong result = 0L;
	gchar* cmd = NULL;
	gchar* _tmp0_;
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gint ret_val = 0;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	gint _tmp7_;
#line 569 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (path != NULL, 0L);
#line 573 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp0_ = g_strdup ("");
#line 573 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	cmd = _tmp0_;
#line 578 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp1_ = tee_jee_file_system_escape_single_quote (path);
#line 578 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp2_ = _tmp1_;
#line 578 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp3_ = g_strdup_printf ("find '%s' | wc -l", _tmp2_);
#line 578 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (cmd);
#line 578 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	cmd = _tmp3_;
#line 578 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (_tmp2_);
#line 579 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp4_ = cmd;
#line 579 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp7_ = tee_jee_process_helper_exec_script_sync (_tmp4_, &_tmp5_, &_tmp6_, FALSE, FALSE, TRUE, FALSE);
#line 579 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_out);
#line 579 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	std_out = _tmp5_;
#line 579 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_err);
#line 579 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	std_err = _tmp6_;
#line 579 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	ret_val = _tmp7_;
#line 580 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	result = atol (std_out);
#line 580 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_err);
#line 580 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_out);
#line 580 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (cmd);
#line 580 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	return result;
#line 3413 "TeeJee.FileSystem.c"
}


glong
tee_jee_file_system_dir_size (const gchar* path)
{
	glong result = 0L;
	gchar* cmd = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	gchar** _tmp6_;
	gchar** _tmp7_;
	gchar** _tmp8_;
	gint _tmp8__length1;
	const gchar* _tmp9_;
	glong _tmp10_;
#line 584 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (path != NULL, 0L);
#line 588 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp0_ = tee_jee_file_system_escape_single_quote (path);
#line 588 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp1_ = _tmp0_;
#line 588 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp2_ = g_strdup_printf ("du -s -b '%s'", _tmp1_);
#line 588 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp3_ = _tmp2_;
#line 588 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (_tmp1_);
#line 588 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	cmd = _tmp3_;
#line 590 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	tee_jee_process_helper_exec_sync (cmd, &_tmp4_, &_tmp5_);
#line 590 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_out);
#line 590 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	std_out = _tmp4_;
#line 590 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_err);
#line 590 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	std_err = _tmp5_;
#line 591 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp7_ = _tmp6_ = g_strsplit (std_out, "\t", 0);
#line 591 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp8_ = _tmp7_;
#line 591 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp8__length1 = _vala_array_length (_tmp6_);
#line 591 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp9_ = _tmp8_[0];
#line 591 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp10_ = atol (_tmp9_);
#line 591 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp8_ = (_vala_array_free (_tmp8_, _tmp8__length1, (GDestroyNotify) g_free), NULL);
#line 591 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	result = _tmp10_;
#line 591 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_err);
#line 591 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_out);
#line 591 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (cmd);
#line 591 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	return result;
#line 3482 "TeeJee.FileSystem.c"
}


glong
tee_jee_file_system_dir_size_kb (const gchar* path)
{
	glong result = 0L;
#line 595 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (path != NULL, 0L);
#line 599 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	result = (glong) (tee_jee_file_system_dir_size (path) / 1024.0);
#line 599 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	return result;
#line 3496 "TeeJee.FileSystem.c"
}


static gint
string_index_of (const gchar* self,
                 const gchar* needle,
                 gint start_index)
{
	gint result = 0;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 1025 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1025 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, 0);
#line 1026 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp0_ = strstr (((gchar*) self) + start_index, (gchar*) needle);
#line 1026 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1028 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1028 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 3521 "TeeJee.FileSystem.c"
		gchar* _tmp2_;
#line 1029 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1029 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1029 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		return result;
#line 3529 "TeeJee.FileSystem.c"
	} else {
#line 1031 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		result = -1;
#line 1031 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		return result;
#line 3535 "TeeJee.FileSystem.c"
	}
}


gboolean
tee_jee_file_system_file_tar_encrypt (const gchar* src_file,
                                      const gchar* dst_file,
                                      const gchar* password)
{
	gboolean result = FALSE;
#line 605 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (src_file != NULL, FALSE);
#line 605 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (dst_file != NULL, FALSE);
#line 605 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (password != NULL, FALSE);
#line 606 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	if (tee_jee_file_system_file_exists (src_file)) {
#line 3554 "TeeJee.FileSystem.c"
		gchar* src_dir = NULL;
		gchar* _tmp0_;
		gchar* src_name = NULL;
		gchar* _tmp1_;
		gchar* dst_dir = NULL;
		gchar* _tmp2_;
		gchar* dst_name = NULL;
		gchar* _tmp3_;
		gchar* tar_name = NULL;
		const gchar* _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* tar_file = NULL;
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* cmd = NULL;
		const gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		const gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		const gchar* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		const gchar* _tmp21_;
		gchar* _tmp22_;
		gchar* _tmp23_;
		const gchar* _tmp24_;
		gchar* _tmp25_;
		gchar* _tmp26_;
		gchar* _tmp27_;
		gchar* _tmp28_;
		gchar* _tmp29_;
		const gchar* _tmp30_;
		const gchar* _tmp31_;
		gchar* _tmp32_;
		gchar* _tmp33_;
		gchar* _tmp34_;
		gchar* _tmp35_;
		gchar* _tmp36_;
		const gchar* _tmp37_;
		gchar* stdout = NULL;
		gchar* stderr = NULL;
		gint status = 0;
		const gchar* _tmp38_;
		gchar* _tmp39_ = NULL;
		gchar* _tmp40_ = NULL;
		gint _tmp41_;
		gint _tmp42_;
#line 607 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		if (tee_jee_file_system_file_exists (dst_file)) {
#line 608 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			tee_jee_file_system_file_delete (dst_file);
#line 3612 "TeeJee.FileSystem.c"
		}
#line 611 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp0_ = tee_jee_file_system_file_parent (src_file);
#line 611 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		src_dir = _tmp0_;
#line 612 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp1_ = tee_jee_file_system_file_basename (src_file);
#line 612 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		src_name = _tmp1_;
#line 614 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp2_ = tee_jee_file_system_file_parent (dst_file);
#line 614 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		dst_dir = _tmp2_;
#line 615 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp3_ = tee_jee_file_system_file_basename (dst_file);
#line 615 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		dst_name = _tmp3_;
#line 616 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp4_ = dst_name;
#line 616 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp5_ = dst_name;
#line 616 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp6_ = string_slice (_tmp4_, (glong) 0, (glong) string_index_of (_tmp5_, ".gpg", 0));
#line 616 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		tar_name = _tmp6_;
#line 617 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp7_ = dst_dir;
#line 617 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp8_ = tar_name;
#line 617 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp9_ = g_strdup_printf ("%s/%s", _tmp7_, _tmp8_);
#line 617 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		tar_file = _tmp9_;
#line 619 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp10_ = tar_file;
#line 619 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp11_ = tee_jee_file_system_escape_single_quote (_tmp10_);
#line 619 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp12_ = _tmp11_;
#line 619 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp13_ = src_dir;
#line 619 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp14_ = tee_jee_file_system_escape_single_quote (_tmp13_);
#line 619 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp15_ = _tmp14_;
#line 619 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp16_ = src_name;
#line 619 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp17_ = tee_jee_file_system_escape_single_quote (_tmp16_);
#line 619 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp18_ = _tmp17_;
#line 619 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp19_ = g_strdup_printf ("tar cvf '%s' --overwrite -C '%s' '%s'\n", _tmp12_, _tmp15_, _tmp18_);
#line 619 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp20_ = _tmp19_;
#line 619 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp18_);
#line 619 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp15_);
#line 619 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp12_);
#line 619 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		cmd = _tmp20_;
#line 624 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp21_ = cmd;
#line 624 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp22_ = tee_jee_file_system_escape_single_quote (dst_file);
#line 624 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp23_ = _tmp22_;
#line 624 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp24_ = tar_file;
#line 624 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp25_ = tee_jee_file_system_escape_single_quote (_tmp24_);
#line 624 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp26_ = _tmp25_;
#line 624 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp27_ = g_strdup_printf ("gpg --passphrase '%s' -o '%s' --symmetric '%s'\n", password, _tmp23_, _tmp26_);
#line 624 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp28_ = _tmp27_;
#line 624 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp29_ = g_strconcat (_tmp21_, _tmp28_, NULL);
#line 624 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (cmd);
#line 624 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		cmd = _tmp29_;
#line 624 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp28_);
#line 624 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp26_);
#line 624 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp23_);
#line 629 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp30_ = cmd;
#line 629 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp31_ = tar_file;
#line 629 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp32_ = tee_jee_file_system_escape_single_quote (_tmp31_);
#line 629 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp33_ = _tmp32_;
#line 629 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp34_ = g_strdup_printf ("rm -f '%s'\n", _tmp33_);
#line 629 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp35_ = _tmp34_;
#line 629 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp36_ = g_strconcat (_tmp30_, _tmp35_, NULL);
#line 629 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (cmd);
#line 629 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		cmd = _tmp36_;
#line 629 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp35_);
#line 629 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp33_);
#line 631 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp37_ = cmd;
#line 631 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_debug (_tmp37_);
#line 634 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp38_ = cmd;
#line 634 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp41_ = tee_jee_process_helper_exec_script_sync (_tmp38_, &_tmp39_, &_tmp40_, FALSE, FALSE, TRUE, FALSE);
#line 634 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (stdout);
#line 634 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		stdout = _tmp39_;
#line 634 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (stderr);
#line 634 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		stderr = _tmp40_;
#line 634 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		status = _tmp41_;
#line 635 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp42_ = status;
#line 635 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		if (_tmp42_ == 0) {
#line 636 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			result = TRUE;
#line 636 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (stderr);
#line 636 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (stdout);
#line 636 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (cmd);
#line 636 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (tar_file);
#line 636 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (tar_name);
#line 636 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (dst_name);
#line 636 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (dst_dir);
#line 636 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (src_name);
#line 636 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (src_dir);
#line 636 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			return result;
#line 3770 "TeeJee.FileSystem.c"
		} else {
			const gchar* _tmp43_;
#line 639 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp43_ = stderr;
#line 639 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			tee_jee_logging_log_msg (_tmp43_, FALSE);
#line 3777 "TeeJee.FileSystem.c"
		}
#line 606 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (stderr);
#line 606 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (stdout);
#line 606 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (cmd);
#line 606 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (tar_file);
#line 606 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (tar_name);
#line 606 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (dst_name);
#line 606 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (dst_dir);
#line 606 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (src_name);
#line 606 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (src_dir);
#line 3797 "TeeJee.FileSystem.c"
	}
#line 643 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	result = FALSE;
#line 643 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	return result;
#line 3803 "TeeJee.FileSystem.c"
}


gchar*
tee_jee_file_system_file_decrypt_untar_read (const gchar* src_file,
                                             const gchar* password)
{
	gchar* result = NULL;
	gchar* _tmp23_;
#line 647 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (src_file != NULL, NULL);
#line 647 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (password != NULL, NULL);
#line 649 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	if (tee_jee_file_system_file_exists (src_file)) {
#line 3819 "TeeJee.FileSystem.c"
		gchar* cmd = NULL;
		gchar* _tmp0_;
		const gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
		const gchar* _tmp9_;
		gchar* _tmp10_;
		const gchar* _tmp11_;
		gchar* std_out = NULL;
		gchar* std_err = NULL;
		gint status = 0;
		const gchar* _tmp12_;
		gchar* _tmp13_ = NULL;
		gchar* _tmp14_ = NULL;
		gint _tmp15_;
		gint _tmp16_;
#line 656 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp0_ = g_strdup ("");
#line 656 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		cmd = _tmp0_;
#line 658 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp1_ = cmd;
#line 658 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp2_ = tee_jee_file_system_escape_single_quote (src_file);
#line 658 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp3_ = _tmp2_;
#line 658 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp4_ = g_strdup_printf ("gpg --quiet --no-verbose --passphrase '%s' -o- --decrypt '%s'", password, _tmp3_);
#line 658 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp5_ = _tmp4_;
#line 658 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp6_ = g_strconcat (_tmp1_, _tmp5_, NULL);
#line 658 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (cmd);
#line 658 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		cmd = _tmp6_;
#line 658 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp5_);
#line 658 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp3_);
#line 662 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp7_ = cmd;
#line 662 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp8_ = g_strconcat (_tmp7_, " | tar xf - --to-stdout 2>/dev/null\n", NULL);
#line 662 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (cmd);
#line 662 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		cmd = _tmp8_;
#line 663 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp9_ = cmd;
#line 663 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp10_ = g_strconcat (_tmp9_, "exit $?\n", NULL);
#line 663 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (cmd);
#line 663 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		cmd = _tmp10_;
#line 665 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp11_ = cmd;
#line 665 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_debug (_tmp11_);
#line 668 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp12_ = cmd;
#line 668 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp15_ = tee_jee_process_helper_exec_script_sync (_tmp12_, &_tmp13_, &_tmp14_, FALSE, FALSE, TRUE, FALSE);
#line 668 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (std_out);
#line 668 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		std_out = _tmp13_;
#line 668 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (std_err);
#line 668 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		std_err = _tmp14_;
#line 668 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		status = _tmp15_;
#line 669 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp16_ = status;
#line 669 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		if (_tmp16_ == 0) {
#line 670 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			result = std_out;
#line 670 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (std_err);
#line 670 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (cmd);
#line 670 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			return result;
#line 3911 "TeeJee.FileSystem.c"
		} else {
			const gchar* _tmp17_;
			gchar* _tmp18_;
#line 673 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp17_ = std_err;
#line 673 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			tee_jee_logging_log_error (_tmp17_, FALSE, FALSE);
#line 674 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp18_ = g_strdup ("");
#line 674 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			result = _tmp18_;
#line 674 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (std_err);
#line 674 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (std_out);
#line 674 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (cmd);
#line 674 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			return result;
#line 3931 "TeeJee.FileSystem.c"
		}
#line 649 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (std_err);
#line 649 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (std_out);
#line 649 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (cmd);
#line 3939 "TeeJee.FileSystem.c"
	} else {
		gchar* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
#line 678 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp19_ = g_strdup_printf (": %s", src_file);
#line 678 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp20_ = _tmp19_;
#line 678 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp21_ = g_strconcat (_ ("File is missing"), _tmp20_, NULL);
#line 678 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp22_ = _tmp21_;
#line 678 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp22_, FALSE, FALSE);
#line 678 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp22_);
#line 678 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp20_);
#line 3959 "TeeJee.FileSystem.c"
	}
#line 681 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp23_ = g_strdup ("");
#line 681 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	result = _tmp23_;
#line 681 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	return result;
#line 3967 "TeeJee.FileSystem.c"
}


gboolean
tee_jee_file_system_decrypt_and_untar (const gchar* src_file,
                                       const gchar* dst_file,
                                       const gchar* password)
{
	gboolean result = FALSE;
#line 685 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (src_file != NULL, FALSE);
#line 685 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (dst_file != NULL, FALSE);
#line 685 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (password != NULL, FALSE);
#line 686 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	if (tee_jee_file_system_file_exists (src_file)) {
#line 3985 "TeeJee.FileSystem.c"
		gchar* src_dir = NULL;
		gchar* _tmp0_;
		gchar* src_name = NULL;
		gchar* _tmp1_;
		gchar* tar_name = NULL;
		const gchar* _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* tar_file = NULL;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* cmd = NULL;
		gchar* _tmp8_;
		const gchar* _tmp9_;
		const gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		const gchar* _tmp16_;
		const gchar* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
		gchar* _tmp23_;
		gchar* _tmp24_;
		const gchar* _tmp25_;
		gchar* _tmp26_;
		const gchar* _tmp27_;
		const gchar* _tmp28_;
		gchar* _tmp29_;
		gchar* _tmp30_;
		gchar* _tmp31_;
		gchar* _tmp32_;
		gchar* _tmp33_;
		gchar* _tmp34_;
		gchar* _tmp35_;
		gchar* _tmp36_;
		gchar* _tmp37_;
		const gchar* _tmp38_;
		const gchar* _tmp39_;
		gchar* _tmp40_;
		gchar* _tmp41_;
		gchar* _tmp42_;
		gchar* _tmp43_;
		gchar* _tmp44_;
		const gchar* _tmp45_;
		gchar* stdout = NULL;
		gchar* stderr = NULL;
		gint status = 0;
		const gchar* _tmp46_;
		gchar* _tmp47_ = NULL;
		gchar* _tmp48_ = NULL;
		gint _tmp49_;
		gint _tmp50_;
#line 687 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		if (tee_jee_file_system_file_exists (dst_file)) {
#line 688 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			tee_jee_file_system_file_delete (dst_file);
#line 4049 "TeeJee.FileSystem.c"
		}
#line 691 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp0_ = tee_jee_file_system_file_parent (src_file);
#line 691 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		src_dir = _tmp0_;
#line 692 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp1_ = tee_jee_file_system_file_basename (src_file);
#line 692 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		src_name = _tmp1_;
#line 693 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp2_ = src_name;
#line 693 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp3_ = src_name;
#line 693 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp4_ = string_slice (_tmp2_, (glong) 0, (glong) string_index_of (_tmp3_, ".gpg", 0));
#line 693 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		tar_name = _tmp4_;
#line 694 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp5_ = src_dir;
#line 694 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp6_ = tar_name;
#line 694 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp7_ = g_strdup_printf ("%s/%s", _tmp5_, _tmp6_);
#line 694 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		tar_file = _tmp7_;
#line 696 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp8_ = g_strdup ("");
#line 696 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		cmd = _tmp8_;
#line 699 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp9_ = cmd;
#line 699 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp10_ = tar_file;
#line 699 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp11_ = tee_jee_file_system_escape_single_quote (_tmp10_);
#line 699 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp12_ = _tmp11_;
#line 699 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp13_ = g_strdup_printf ("rm -f '%s'\n", _tmp12_);
#line 699 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp14_ = _tmp13_;
#line 699 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp15_ = g_strconcat (_tmp9_, _tmp14_, NULL);
#line 699 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (cmd);
#line 699 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		cmd = _tmp15_;
#line 699 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp14_);
#line 699 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp12_);
#line 701 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp16_ = cmd;
#line 701 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp17_ = tar_file;
#line 701 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp18_ = tee_jee_file_system_escape_single_quote (_tmp17_);
#line 701 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp19_ = _tmp18_;
#line 701 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp20_ = tee_jee_file_system_escape_single_quote (src_file);
#line 701 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp21_ = _tmp20_;
#line 701 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp22_ = g_strdup_printf ("gpg --passphrase '%s' -o '%s' --decrypt '%s'\n", password, _tmp19_, _tmp21_);
#line 701 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp23_ = _tmp22_;
#line 701 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp24_ = g_strconcat (_tmp16_, _tmp23_, NULL);
#line 701 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (cmd);
#line 701 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		cmd = _tmp24_;
#line 701 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp23_);
#line 701 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp21_);
#line 701 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp19_);
#line 706 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp25_ = cmd;
#line 706 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp26_ = g_strconcat (_tmp25_, "status=$?; if [ $status -ne 0 ]; then exit $status; fi\n", NULL);
#line 706 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (cmd);
#line 706 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		cmd = _tmp26_;
#line 708 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp27_ = cmd;
#line 708 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp28_ = tar_file;
#line 708 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp29_ = tee_jee_file_system_escape_single_quote (_tmp28_);
#line 708 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp30_ = _tmp29_;
#line 708 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp31_ = tee_jee_file_system_file_parent (dst_file);
#line 708 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp32_ = _tmp31_;
#line 708 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp33_ = tee_jee_file_system_escape_single_quote (_tmp32_);
#line 708 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp34_ = _tmp33_;
#line 708 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp35_ = g_strdup_printf ("tar xvf '%s' --overwrite --same-permissions -C '%s'\n", _tmp30_, _tmp34_);
#line 708 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp36_ = _tmp35_;
#line 708 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp37_ = g_strconcat (_tmp27_, _tmp36_, NULL);
#line 708 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (cmd);
#line 708 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		cmd = _tmp37_;
#line 708 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp36_);
#line 708 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp34_);
#line 708 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp32_);
#line 708 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp30_);
#line 712 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp38_ = cmd;
#line 712 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp39_ = tar_file;
#line 712 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp40_ = tee_jee_file_system_escape_single_quote (_tmp39_);
#line 712 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp41_ = _tmp40_;
#line 712 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp42_ = g_strdup_printf ("rm -f '%s'\n", _tmp41_);
#line 712 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp43_ = _tmp42_;
#line 712 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp44_ = g_strconcat (_tmp38_, _tmp43_, NULL);
#line 712 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (cmd);
#line 712 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		cmd = _tmp44_;
#line 712 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp43_);
#line 712 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp41_);
#line 714 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp45_ = cmd;
#line 714 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_debug (_tmp45_);
#line 717 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp46_ = cmd;
#line 717 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp49_ = tee_jee_process_helper_exec_script_sync (_tmp46_, &_tmp47_, &_tmp48_, FALSE, FALSE, TRUE, FALSE);
#line 717 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (stdout);
#line 717 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		stdout = _tmp47_;
#line 717 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (stderr);
#line 717 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		stderr = _tmp48_;
#line 717 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		status = _tmp49_;
#line 718 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp50_ = status;
#line 718 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		if (_tmp50_ == 0) {
#line 719 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			result = TRUE;
#line 719 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (stderr);
#line 719 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (stdout);
#line 719 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (cmd);
#line 719 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (tar_file);
#line 719 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (tar_name);
#line 719 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (src_name);
#line 719 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (src_dir);
#line 719 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			return result;
#line 4233 "TeeJee.FileSystem.c"
		} else {
			const gchar* _tmp51_;
#line 722 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp51_ = stderr;
#line 722 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			tee_jee_logging_log_error (_tmp51_, FALSE, FALSE);
#line 723 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			result = FALSE;
#line 723 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (stderr);
#line 723 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (stdout);
#line 723 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (cmd);
#line 723 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (tar_file);
#line 723 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (tar_name);
#line 723 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (src_name);
#line 723 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (src_dir);
#line 723 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			return result;
#line 4258 "TeeJee.FileSystem.c"
		}
#line 686 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (stderr);
#line 686 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (stdout);
#line 686 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (cmd);
#line 686 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (tar_file);
#line 686 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (tar_name);
#line 686 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (src_name);
#line 686 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (src_dir);
#line 4274 "TeeJee.FileSystem.c"
	} else {
		gchar* _tmp52_;
		gchar* _tmp53_;
		gchar* _tmp54_;
		gchar* _tmp55_;
#line 727 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp52_ = g_strdup_printf (": %s", src_file);
#line 727 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp53_ = _tmp52_;
#line 727 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp54_ = g_strconcat (_ ("File is missing"), _tmp53_, NULL);
#line 727 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp55_ = _tmp54_;
#line 727 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp55_, FALSE, FALSE);
#line 727 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp55_);
#line 727 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp53_);
#line 4294 "TeeJee.FileSystem.c"
	}
#line 730 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	result = FALSE;
#line 730 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	return result;
#line 4300 "TeeJee.FileSystem.c"
}


gchar*
tee_jee_file_system_hash_md5 (const gchar* path)
{
	gchar* result = NULL;
	GChecksum* checksum = NULL;
	GChecksum* _tmp0_;
	FILE* stream = NULL;
	FILE* _tmp1_;
	guint8 fbuf[100] = {0};
	gsize size = 0UL;
	const gchar* digest = NULL;
	GChecksum* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
#line 735 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 736 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp0_ = g_checksum_new (G_CHECKSUM_MD5);
#line 736 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	checksum = _tmp0_;
#line 737 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp1_ = g_fopen (path, "rb");
#line 737 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	stream = _tmp1_;
#line 741 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	while (TRUE) {
#line 4330 "TeeJee.FileSystem.c"
		FILE* _tmp2_;
		gsize _tmp3_;
		GChecksum* _tmp4_;
		gsize _tmp5_;
#line 741 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp2_ = stream;
#line 741 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		size = fread (fbuf, (gsize) 1, 100, _tmp2_);
#line 741 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp3_ = size;
#line 741 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		if (!(_tmp3_ > ((gsize) 0))) {
#line 741 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			break;
#line 4345 "TeeJee.FileSystem.c"
		}
#line 742 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp4_ = checksum;
#line 742 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp5_ = size;
#line 742 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		g_checksum_update (_tmp4_, fbuf, _tmp5_);
#line 4353 "TeeJee.FileSystem.c"
	}
#line 745 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp6_ = checksum;
#line 745 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp7_ = g_checksum_get_string (_tmp6_);
#line 745 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	digest = _tmp7_;
#line 747 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp8_ = g_strdup (digest);
#line 747 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	result = _tmp8_;
#line 747 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_fclose0 (stream);
#line 747 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_g_checksum_free0 (checksum);
#line 747 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	return result;
#line 4371 "TeeJee.FileSystem.c"
}


gchar*
tee_jee_file_system_format_file_size (guint64 size,
                                      gboolean binary_units,
                                      const gchar* unit,
                                      gboolean show_units,
                                      gint decimals)
{
	gchar* result = NULL;
	gint _tmp0_ = 0;
	guint64 unit_k = 0ULL;
	guint64 _tmp1_ = 0ULL;
	guint64 unit_m = 0ULL;
	guint64 _tmp4_ = 0ULL;
	guint64 unit_g = 0ULL;
	guint64 _tmp7_ = 0ULL;
	guint64 unit_t = 0ULL;
	gchar* txt = NULL;
	gchar* _tmp10_;
	gboolean _tmp11_ = FALSE;
	guint64 _tmp12_;
#line 752 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (unit != NULL, NULL);
#line 756 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	if (binary_units) {
#line 756 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp0_ = 1024;
#line 4401 "TeeJee.FileSystem.c"
	} else {
#line 756 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp0_ = 1000;
#line 4405 "TeeJee.FileSystem.c"
	}
#line 756 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	unit_k = (guint64) _tmp0_;
#line 757 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	if (binary_units) {
#line 4411 "TeeJee.FileSystem.c"
		guint64 _tmp2_;
#line 757 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp2_ = unit_k;
#line 757 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp1_ = 1024 * _tmp2_;
#line 4417 "TeeJee.FileSystem.c"
	} else {
		guint64 _tmp3_;
#line 757 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp3_ = unit_k;
#line 757 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp1_ = 1000 * _tmp3_;
#line 4424 "TeeJee.FileSystem.c"
	}
#line 757 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	unit_m = _tmp1_;
#line 758 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	if (binary_units) {
#line 4430 "TeeJee.FileSystem.c"
		guint64 _tmp5_;
#line 758 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp5_ = unit_m;
#line 758 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp4_ = 1024 * _tmp5_;
#line 4436 "TeeJee.FileSystem.c"
	} else {
		guint64 _tmp6_;
#line 758 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp6_ = unit_m;
#line 758 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp4_ = 1000 * _tmp6_;
#line 4443 "TeeJee.FileSystem.c"
	}
#line 758 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	unit_g = _tmp4_;
#line 759 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	if (binary_units) {
#line 4449 "TeeJee.FileSystem.c"
		guint64 _tmp8_;
#line 759 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp8_ = unit_g;
#line 759 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp7_ = 1024 * _tmp8_;
#line 4455 "TeeJee.FileSystem.c"
	} else {
		guint64 _tmp9_;
#line 759 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp9_ = unit_g;
#line 759 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp7_ = 1000 * _tmp9_;
#line 4462 "TeeJee.FileSystem.c"
	}
#line 759 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	unit_t = _tmp7_;
#line 763 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp10_ = g_strdup ("");
#line 763 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	txt = _tmp10_;
#line 765 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp12_ = unit_t;
#line 765 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	if (size > _tmp12_) {
#line 4474 "TeeJee.FileSystem.c"
		gboolean _tmp13_ = FALSE;
		gint _tmp14_;
		gint _tmp15_;
#line 765 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp14_ = strlen (unit);
#line 765 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp15_ = _tmp14_;
#line 765 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		if (_tmp15_ == 0) {
#line 765 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp13_ = TRUE;
#line 4486 "TeeJee.FileSystem.c"
		} else {
#line 765 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp13_ = g_strcmp0 (unit, "t") == 0;
#line 4490 "TeeJee.FileSystem.c"
		}
#line 765 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp11_ = _tmp13_;
#line 4494 "TeeJee.FileSystem.c"
	} else {
#line 765 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp11_ = FALSE;
#line 4498 "TeeJee.FileSystem.c"
	}
#line 765 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	if (_tmp11_) {
#line 4502 "TeeJee.FileSystem.c"
		const gchar* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
		guint64 _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
#line 766 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp16_ = txt;
#line 766 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp17_ = g_strdup_printf ("%%'0.%df", decimals);
#line 766 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp18_ = _tmp17_;
#line 766 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp19_ = unit_t;
#line 766 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp20_ = g_strdup_printf (_tmp18_, size / (1.0 * _tmp19_));
#line 766 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp21_ = _tmp20_;
#line 766 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp22_ = g_strconcat (_tmp16_, _tmp21_, NULL);
#line 766 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (txt);
#line 766 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		txt = _tmp22_;
#line 766 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp21_);
#line 766 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp18_);
#line 767 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		if (show_units) {
#line 4534 "TeeJee.FileSystem.c"
			const gchar* _tmp23_ = NULL;
			const gchar* _tmp24_;
			gchar* _tmp25_;
			gchar* _tmp26_;
			gchar* _tmp27_;
#line 768 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			if (binary_units) {
#line 768 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
				_tmp23_ = "Ti";
#line 4544 "TeeJee.FileSystem.c"
			} else {
#line 768 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
				_tmp23_ = "T";
#line 4548 "TeeJee.FileSystem.c"
			}
#line 768 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp24_ = txt;
#line 768 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp25_ = g_strdup_printf (" %sB", _tmp23_);
#line 768 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp26_ = _tmp25_;
#line 768 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp27_ = g_strconcat (_tmp24_, _tmp26_, NULL);
#line 768 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (txt);
#line 768 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			txt = _tmp27_;
#line 768 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (_tmp26_);
#line 4564 "TeeJee.FileSystem.c"
		}
	} else {
		gboolean _tmp28_ = FALSE;
		guint64 _tmp29_;
#line 771 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp29_ = unit_g;
#line 771 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		if (size > _tmp29_) {
#line 4573 "TeeJee.FileSystem.c"
			gboolean _tmp30_ = FALSE;
			gint _tmp31_;
			gint _tmp32_;
#line 771 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp31_ = strlen (unit);
#line 771 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp32_ = _tmp31_;
#line 771 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			if (_tmp32_ == 0) {
#line 771 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
				_tmp30_ = TRUE;
#line 4585 "TeeJee.FileSystem.c"
			} else {
#line 771 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
				_tmp30_ = g_strcmp0 (unit, "g") == 0;
#line 4589 "TeeJee.FileSystem.c"
			}
#line 771 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp28_ = _tmp30_;
#line 4593 "TeeJee.FileSystem.c"
		} else {
#line 771 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp28_ = FALSE;
#line 4597 "TeeJee.FileSystem.c"
		}
#line 771 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		if (_tmp28_) {
#line 4601 "TeeJee.FileSystem.c"
			const gchar* _tmp33_;
			gchar* _tmp34_;
			gchar* _tmp35_;
			guint64 _tmp36_;
			gchar* _tmp37_;
			gchar* _tmp38_;
			gchar* _tmp39_;
#line 772 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp33_ = txt;
#line 772 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp34_ = g_strdup_printf ("%%'0.%df", decimals);
#line 772 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp35_ = _tmp34_;
#line 772 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp36_ = unit_g;
#line 772 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp37_ = g_strdup_printf (_tmp35_, size / (1.0 * _tmp36_));
#line 772 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp38_ = _tmp37_;
#line 772 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp39_ = g_strconcat (_tmp33_, _tmp38_, NULL);
#line 772 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (txt);
#line 772 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			txt = _tmp39_;
#line 772 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (_tmp38_);
#line 772 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (_tmp35_);
#line 773 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			if (show_units) {
#line 4633 "TeeJee.FileSystem.c"
				const gchar* _tmp40_ = NULL;
				const gchar* _tmp41_;
				gchar* _tmp42_;
				gchar* _tmp43_;
				gchar* _tmp44_;
#line 774 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
				if (binary_units) {
#line 774 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
					_tmp40_ = "Gi";
#line 4643 "TeeJee.FileSystem.c"
				} else {
#line 774 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
					_tmp40_ = "G";
#line 4647 "TeeJee.FileSystem.c"
				}
#line 774 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
				_tmp41_ = txt;
#line 774 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
				_tmp42_ = g_strdup_printf (" %sB", _tmp40_);
#line 774 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
				_tmp43_ = _tmp42_;
#line 774 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
				_tmp44_ = g_strconcat (_tmp41_, _tmp43_, NULL);
#line 774 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
				_g_free0 (txt);
#line 774 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
				txt = _tmp44_;
#line 774 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
				_g_free0 (_tmp43_);
#line 4663 "TeeJee.FileSystem.c"
			}
		} else {
			gboolean _tmp45_ = FALSE;
			guint64 _tmp46_;
#line 777 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_tmp46_ = unit_m;
#line 777 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			if (size > _tmp46_) {
#line 4672 "TeeJee.FileSystem.c"
				gboolean _tmp47_ = FALSE;
				gint _tmp48_;
				gint _tmp49_;
#line 777 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
				_tmp48_ = strlen (unit);
#line 777 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
				_tmp49_ = _tmp48_;
#line 777 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
				if (_tmp49_ == 0) {
#line 777 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
					_tmp47_ = TRUE;
#line 4684 "TeeJee.FileSystem.c"
				} else {
#line 777 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
					_tmp47_ = g_strcmp0 (unit, "m") == 0;
#line 4688 "TeeJee.FileSystem.c"
				}
#line 777 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
				_tmp45_ = _tmp47_;
#line 4692 "TeeJee.FileSystem.c"
			} else {
#line 777 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
				_tmp45_ = FALSE;
#line 4696 "TeeJee.FileSystem.c"
			}
#line 777 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			if (_tmp45_) {
#line 4700 "TeeJee.FileSystem.c"
				const gchar* _tmp50_;
				gchar* _tmp51_;
				gchar* _tmp52_;
				guint64 _tmp53_;
				gchar* _tmp54_;
				gchar* _tmp55_;
				gchar* _tmp56_;
#line 778 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
				_tmp50_ = txt;
#line 778 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
				_tmp51_ = g_strdup_printf ("%%'0.%df", decimals);
#line 778 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
				_tmp52_ = _tmp51_;
#line 778 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
				_tmp53_ = unit_m;
#line 778 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
				_tmp54_ = g_strdup_printf (_tmp52_, size / (1.0 * _tmp53_));
#line 778 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
				_tmp55_ = _tmp54_;
#line 778 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
				_tmp56_ = g_strconcat (_tmp50_, _tmp55_, NULL);
#line 778 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
				_g_free0 (txt);
#line 778 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
				txt = _tmp56_;
#line 778 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
				_g_free0 (_tmp55_);
#line 778 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
				_g_free0 (_tmp52_);
#line 779 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
				if (show_units) {
#line 4732 "TeeJee.FileSystem.c"
					const gchar* _tmp57_ = NULL;
					const gchar* _tmp58_;
					gchar* _tmp59_;
					gchar* _tmp60_;
					gchar* _tmp61_;
#line 780 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
					if (binary_units) {
#line 780 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
						_tmp57_ = "Mi";
#line 4742 "TeeJee.FileSystem.c"
					} else {
#line 780 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
						_tmp57_ = "M";
#line 4746 "TeeJee.FileSystem.c"
					}
#line 780 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
					_tmp58_ = txt;
#line 780 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
					_tmp59_ = g_strdup_printf (" %sB", _tmp57_);
#line 780 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
					_tmp60_ = _tmp59_;
#line 780 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
					_tmp61_ = g_strconcat (_tmp58_, _tmp60_, NULL);
#line 780 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
					_g_free0 (txt);
#line 780 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
					txt = _tmp61_;
#line 780 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
					_g_free0 (_tmp60_);
#line 4762 "TeeJee.FileSystem.c"
				}
			} else {
				gboolean _tmp62_ = FALSE;
				guint64 _tmp63_;
#line 783 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
				_tmp63_ = unit_k;
#line 783 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
				if (size > _tmp63_) {
#line 4771 "TeeJee.FileSystem.c"
					gboolean _tmp64_ = FALSE;
					gint _tmp65_;
					gint _tmp66_;
#line 783 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
					_tmp65_ = strlen (unit);
#line 783 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
					_tmp66_ = _tmp65_;
#line 783 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
					if (_tmp66_ == 0) {
#line 783 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
						_tmp64_ = TRUE;
#line 4783 "TeeJee.FileSystem.c"
					} else {
#line 783 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
						_tmp64_ = g_strcmp0 (unit, "k") == 0;
#line 4787 "TeeJee.FileSystem.c"
					}
#line 783 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
					_tmp62_ = _tmp64_;
#line 4791 "TeeJee.FileSystem.c"
				} else {
#line 783 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
					_tmp62_ = FALSE;
#line 4795 "TeeJee.FileSystem.c"
				}
#line 783 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
				if (_tmp62_) {
#line 4799 "TeeJee.FileSystem.c"
					const gchar* _tmp67_;
					gchar* _tmp68_;
					gchar* _tmp69_;
					guint64 _tmp70_;
					gchar* _tmp71_;
					gchar* _tmp72_;
					gchar* _tmp73_;
#line 784 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
					_tmp67_ = txt;
#line 784 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
					_tmp68_ = g_strdup_printf ("%%'0.%df", decimals);
#line 784 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
					_tmp69_ = _tmp68_;
#line 784 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
					_tmp70_ = unit_k;
#line 784 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
					_tmp71_ = g_strdup_printf (_tmp69_, size / (1.0 * _tmp70_));
#line 784 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
					_tmp72_ = _tmp71_;
#line 784 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
					_tmp73_ = g_strconcat (_tmp67_, _tmp72_, NULL);
#line 784 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
					_g_free0 (txt);
#line 784 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
					txt = _tmp73_;
#line 784 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
					_g_free0 (_tmp72_);
#line 784 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
					_g_free0 (_tmp69_);
#line 785 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
					if (show_units) {
#line 4831 "TeeJee.FileSystem.c"
						const gchar* _tmp74_ = NULL;
						const gchar* _tmp75_;
						gchar* _tmp76_;
						gchar* _tmp77_;
						gchar* _tmp78_;
#line 786 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
						if (binary_units) {
#line 786 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
							_tmp74_ = "Ki";
#line 4841 "TeeJee.FileSystem.c"
						} else {
#line 786 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
							_tmp74_ = "K";
#line 4845 "TeeJee.FileSystem.c"
						}
#line 786 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
						_tmp75_ = txt;
#line 786 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
						_tmp76_ = g_strdup_printf (" %sB", _tmp74_);
#line 786 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
						_tmp77_ = _tmp76_;
#line 786 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
						_tmp78_ = g_strconcat (_tmp75_, _tmp77_, NULL);
#line 786 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
						_g_free0 (txt);
#line 786 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
						txt = _tmp78_;
#line 786 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
						_g_free0 (_tmp77_);
#line 4861 "TeeJee.FileSystem.c"
					}
				} else {
					const gchar* _tmp79_;
					gchar* _tmp80_;
					gchar* _tmp81_;
					gchar* _tmp82_;
#line 790 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
					_tmp79_ = txt;
#line 790 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
					_tmp80_ = g_strdup_printf ("%'0lld", size);
#line 790 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
					_tmp81_ = _tmp80_;
#line 790 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
					_tmp82_ = g_strconcat (_tmp79_, _tmp81_, NULL);
#line 790 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
					_g_free0 (txt);
#line 790 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
					txt = _tmp82_;
#line 790 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
					_g_free0 (_tmp81_);
#line 791 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
					if (show_units) {
#line 4884 "TeeJee.FileSystem.c"
						const gchar* _tmp83_;
						gchar* _tmp84_;
#line 792 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
						_tmp83_ = txt;
#line 792 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
						_tmp84_ = g_strconcat (_tmp83_, " B", NULL);
#line 792 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
						_g_free0 (txt);
#line 792 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
						txt = _tmp84_;
#line 4895 "TeeJee.FileSystem.c"
					}
				}
			}
		}
	}
#line 798 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	result = txt;
#line 798 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	return result;
#line 4905 "TeeJee.FileSystem.c"
}


static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError * _inner_error_ = NULL;
#line 1421 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1421 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1421 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1422 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1422 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 4928 "TeeJee.FileSystem.c"
	} else {
#line 1422 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 4932 "TeeJee.FileSystem.c"
	}
#line 1422 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (_tmp1_) {
#line 1422 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 4938 "TeeJee.FileSystem.c"
	} else {
#line 1422 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 4942 "TeeJee.FileSystem.c"
	}
#line 1422 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (_tmp0_) {
#line 4946 "TeeJee.FileSystem.c"
		gchar* _tmp2_;
#line 1423 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1423 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		result = _tmp2_;
#line 1423 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		return result;
#line 4954 "TeeJee.FileSystem.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1426 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1426 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1426 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error_);
#line 1426 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1426 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1426 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		regex = _tmp6_;
#line 1426 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1426 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			if (_inner_error_->domain == G_REGEX_ERROR) {
#line 4982 "TeeJee.FileSystem.c"
				goto __catch76_g_regex_error;
			}
#line 1426 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1426 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			g_clear_error (&_inner_error_);
#line 1426 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			return NULL;
#line 4991 "TeeJee.FileSystem.c"
		}
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp8_ = regex;
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error_);
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			if (_inner_error_->domain == G_REGEX_ERROR) {
#line 5005 "TeeJee.FileSystem.c"
				goto __catch76_g_regex_error;
			}
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			g_clear_error (&_inner_error_);
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			return NULL;
#line 5016 "TeeJee.FileSystem.c"
		}
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		result = _tmp10_;
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1427 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		return result;
#line 5030 "TeeJee.FileSystem.c"
	}
	goto __finally76;
	__catch76_g_regex_error:
	{
		GError* e = NULL;
#line 1425 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		e = _inner_error_;
#line 1425 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_inner_error_ = NULL;
#line 1429 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		g_assert_not_reached ();
#line 1425 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_g_error_free0 (e);
#line 5044 "TeeJee.FileSystem.c"
	}
	__finally76:
#line 1425 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1425 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1425 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		g_clear_error (&_inner_error_);
#line 1425 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		return NULL;
#line 5055 "TeeJee.FileSystem.c"
	}
}


gchar*
tee_jee_file_system_escape_single_quote (const gchar* file_path)
{
	gchar* result = NULL;
	gchar* _tmp0_;
#line 801 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (file_path != NULL, NULL);
#line 802 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp0_ = string_replace (file_path, "'", "'\\''");
#line 802 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	result = _tmp0_;
#line 802 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	return result;
#line 5073 "TeeJee.FileSystem.c"
}


gint
tee_jee_file_system_chmod (const gchar* file,
                           const gchar* permission)
{
	gint result = 0;
	gchar* cmd = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gint _tmp4_;
#line 807 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (file != NULL, 0);
#line 807 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (permission != NULL, 0);
#line 810 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp0_ = tee_jee_file_system_escape_single_quote (file);
#line 810 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp1_ = _tmp0_;
#line 810 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp2_ = g_strdup_printf ("chmod %s '%s'", permission, _tmp1_);
#line 810 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp3_ = _tmp2_;
#line 810 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (_tmp1_);
#line 810 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	cmd = _tmp3_;
#line 811 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp4_ = tee_jee_process_helper_exec_sync (cmd, NULL, NULL);
#line 811 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	result = _tmp4_;
#line 811 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (cmd);
#line 811 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	return result;
#line 5112 "TeeJee.FileSystem.c"
}


static gchar*
string_strip (const gchar* self)
{
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
#line 1248 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1249 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1249 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1250 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1250 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_strstrip (_tmp1_);
#line 1251 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	result = _result_;
#line 1251 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	return result;
#line 5137 "TeeJee.FileSystem.c"
}


gchar*
tee_jee_file_system_resolve_relative_path (const gchar* filePath)
{
	gchar* result = NULL;
	gchar* filePath2 = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	GError * _inner_error_ = NULL;
#line 815 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (filePath != NULL, NULL);
#line 819 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp0_ = g_strdup (filePath);
#line 819 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	filePath2 = _tmp0_;
#line 820 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp1_ = filePath2;
#line 820 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	if (g_str_has_prefix (_tmp1_, "~")) {
#line 5159 "TeeJee.FileSystem.c"
		const gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
#line 821 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp2_ = g_get_home_dir ();
#line 821 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp3_ = g_strconcat (_tmp2_, "/", NULL);
#line 821 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp4_ = _tmp3_;
#line 821 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp5_ = filePath2;
#line 821 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp6_ = filePath2;
#line 821 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp7_ = strlen (_tmp6_);
#line 821 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp8_ = _tmp7_;
#line 821 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp9_ = string_slice (_tmp5_, (glong) 2, (glong) _tmp8_);
#line 821 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp10_ = _tmp9_;
#line 821 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp11_ = g_strconcat (_tmp4_, _tmp10_, NULL);
#line 821 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (filePath2);
#line 821 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		filePath2 = _tmp11_;
#line 821 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp10_);
#line 821 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp4_);
#line 5198 "TeeJee.FileSystem.c"
	}
	{
		gchar* output = NULL;
		gchar* _tmp12_;
		gchar* cmd = NULL;
		const gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
		const gchar* _tmp18_;
		gchar* _tmp19_ = NULL;
		const gchar* _tmp20_;
		gchar* _tmp21_;
		const gchar* _tmp22_;
#line 825 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp12_ = g_strdup ("");
#line 825 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		output = _tmp12_;
#line 826 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp13_ = filePath2;
#line 826 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp14_ = tee_jee_file_system_escape_single_quote (_tmp13_);
#line 826 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp15_ = _tmp14_;
#line 826 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp16_ = g_strdup_printf ("realpath '%s'", _tmp15_);
#line 826 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp17_ = _tmp16_;
#line 826 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp15_);
#line 826 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		cmd = _tmp17_;
#line 827 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp18_ = cmd;
#line 827 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		g_spawn_command_line_sync (_tmp18_, &_tmp19_, NULL, NULL, &_inner_error_);
#line 827 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (output);
#line 827 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		output = _tmp19_;
#line 827 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 827 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (cmd);
#line 827 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (output);
#line 5246 "TeeJee.FileSystem.c"
			goto __catch77_g_error;
		}
#line 828 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp20_ = output;
#line 828 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp21_ = string_strip (_tmp20_);
#line 828 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (output);
#line 828 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		output = _tmp21_;
#line 829 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp22_ = output;
#line 829 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		if (g_file_test (_tmp22_, G_FILE_TEST_EXISTS)) {
#line 830 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			result = output;
#line 830 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (cmd);
#line 830 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			_g_free0 (filePath2);
#line 830 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
			return result;
#line 5269 "TeeJee.FileSystem.c"
		}
#line 824 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (cmd);
#line 824 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (output);
#line 5275 "TeeJee.FileSystem.c"
	}
	goto __finally77;
	__catch77_g_error:
	{
		GError* e = NULL;
		GError* _tmp23_;
		const gchar* _tmp24_;
#line 824 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		e = _inner_error_;
#line 824 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_inner_error_ = NULL;
#line 834 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp23_ = e;
#line 834 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp24_ = _tmp23_->message;
#line 834 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp24_, FALSE, FALSE);
#line 824 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_error_free0 (e);
#line 5295 "TeeJee.FileSystem.c"
	}
	__finally77:
#line 824 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 824 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_g_free0 (filePath2);
#line 824 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 824 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		g_clear_error (&_inner_error_);
#line 824 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		return NULL;
#line 5308 "TeeJee.FileSystem.c"
	}
#line 837 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	result = filePath2;
#line 837 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	return result;
#line 5314 "TeeJee.FileSystem.c"
}


gint
tee_jee_file_system_rsync (const gchar* sourceDirectory,
                           const gchar* destDirectory,
                           gboolean updateExisting,
                           gboolean deleteExtra)
{
	gint result = 0;
	gchar* cmd = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_ = NULL;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	const gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	const gchar* _tmp21_;
	gint _tmp22_;
#line 840 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (sourceDirectory != NULL, 0);
#line 840 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (destDirectory != NULL, 0);
#line 844 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp0_ = g_strdup ("rsync -avh");
#line 844 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	cmd = _tmp0_;
#line 845 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	if (updateExisting) {
#line 845 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp1_ = "";
#line 5361 "TeeJee.FileSystem.c"
	} else {
#line 845 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp1_ = " --ignore-existing";
#line 5365 "TeeJee.FileSystem.c"
	}
#line 845 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp2_ = cmd;
#line 845 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp3_ = g_strconcat (_tmp2_, _tmp1_, NULL);
#line 845 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (cmd);
#line 845 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	cmd = _tmp3_;
#line 846 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	if (deleteExtra) {
#line 846 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp4_ = " --delete";
#line 5379 "TeeJee.FileSystem.c"
	} else {
#line 846 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
		_tmp4_ = "";
#line 5383 "TeeJee.FileSystem.c"
	}
#line 846 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp5_ = cmd;
#line 846 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp6_ = g_strconcat (_tmp5_, _tmp4_, NULL);
#line 846 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (cmd);
#line 846 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	cmd = _tmp6_;
#line 847 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp7_ = cmd;
#line 847 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp8_ = tee_jee_file_system_escape_single_quote (sourceDirectory);
#line 847 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp9_ = _tmp8_;
#line 847 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp10_ = g_strconcat (_tmp9_, "//", NULL);
#line 847 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp11_ = _tmp10_;
#line 847 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp12_ = g_strdup_printf (" '%s'", _tmp11_);
#line 847 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp13_ = _tmp12_;
#line 847 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp14_ = g_strconcat (_tmp7_, _tmp13_, NULL);
#line 847 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (cmd);
#line 847 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	cmd = _tmp14_;
#line 847 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (_tmp13_);
#line 847 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (_tmp11_);
#line 847 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (_tmp9_);
#line 848 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp15_ = cmd;
#line 848 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp16_ = tee_jee_file_system_escape_single_quote (destDirectory);
#line 848 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp17_ = _tmp16_;
#line 848 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp18_ = g_strdup_printf (" '%s'", _tmp17_);
#line 848 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp19_ = _tmp18_;
#line 848 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp20_ = g_strconcat (_tmp15_, _tmp19_, NULL);
#line 848 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (cmd);
#line 848 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	cmd = _tmp20_;
#line 848 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (_tmp19_);
#line 848 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (_tmp17_);
#line 849 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp21_ = cmd;
#line 849 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_tmp22_ = tee_jee_process_helper_exec_sync (_tmp21_, NULL, NULL);
#line 849 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	result = _tmp22_;
#line 849 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	_g_free0 (cmd);
#line 849 "/builddir/build/BUILD/timeshift-20.03/src/Utility/TeeJee.FileSystem.vala"
	return result;
#line 5449 "TeeJee.FileSystem.c"
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



